      !-----------------------------------------------------------------------
      !  Name:       ERPRT

      !  Purpose:    Print an error message and stop.

      !  Usage:      CALL ERPRT (ICODE, MES)

      !  Arguments:
      !     ICODE  - Integer code for the error message.  (Input)
      !     MES    - Character string containing the error message.  (Input)
      !-----------------------------------------------------------------------
      subroutine prterr(icode, mes)
      !                                  SPECIFICATIONS FOR ARGUMENTS
      INTEGER, INTENT(IN)           :: icode
      CHARACTER (LEN=*), INTENT(IN) :: mes
cf2py intent(callback, hide) f2pystop
      external f2pystop

      CALL f2pystop(icode, mes)
      !WRITE (*, *) 'FEXACT ERROR: ', icode, ' ', mes
      !STOP

      END subroutine prterr

!     -*- f90 -*-
!     This file is autogenerated with f2py (version:2)
!     It contains Fortran 90 wrappers to fortran functions.

      
      subroutine f2pyinittypes(f2pysetupfunc)
      use types, only : dp
      external f2pysetupfunc
      call f2pysetupfunc(dp)
      end subroutine f2pyinittypes

      subroutine f2pywrap_fisher_exact_fexact (nrow, ncol, table, ldtabl&
     &, expect, percnt, emin, wkspace, prt, pre, f2py_table_d0, f2py_tab&
     &le_d1)
      use fisher_exact, only : fexact
      integer nrow
      integer ncol
      integer ldtabl
      real(kind=8) expect
      real(kind=8) percnt
      real(kind=8) emin
      integer wkspace
      real(kind=8) prt
      real(kind=8) pre
      integer f2py_table_d0
      integer f2py_table_d1
      real(kind=8) table(f2py_table_d0,f2py_table_d1)
      call fexact(nrow, ncol, table, ldtabl, expect, percnt, emin, wkspa&
     &ce, prt, pre)
      end subroutine f2pywrap_fisher_exact_fexact
      subroutine f2pywrap_fisher_exact_f2xact (nrow, ncol, table, ldtabl&
     &, expect, percnt, emin, prt, pre, ldkey, ldstp, ntotal, ncols, nro&
     &ws, f2py_table_d0, f2py_table_d1)
      use fisher_exact, only : f2xact
      integer nrow
      integer ncol
      integer ldtabl
      real(kind=8) expect
      real(kind=8) percnt
      real(kind=8) emin
      real(kind=8) prt
      real(kind=8) pre
      integer ldkey
      integer ldstp
      integer ntotal
      integer ncols
      integer nrows
      integer f2py_table_d0
      integer f2py_table_d1
      real(kind=8) table(f2py_table_d0,f2py_table_d1)
      call f2xact(nrow, ncol, table, ldtabl, expect, percnt, emin, prt, &
     &pre, ldkey, ldstp, ntotal, ncols, nrows)
      end subroutine f2pywrap_fisher_exact_f2xact
      subroutine f2pywrap_fisher_exact_f3xact (nrow, irow, ncol, icol, d&
     &lp, mm, fact, tol, f2py_irow_d0, f2py_icol_d0)
      use fisher_exact, only : f3xact
      integer nrow
      integer ncol
      real(kind=8) dlp
      integer mm
      real(kind=8) tol
      integer f2py_irow_d0
      integer f2py_icol_d0
      integer irow(f2py_irow_d0)
      integer icol(f2py_icol_d0)
      real(kind=8) fact(1)
      call f3xact(nrow, irow, ncol, icol, dlp, mm, fact, tol)
      end subroutine f2pywrap_fisher_exact_f3xact
      subroutine f2pywrap_fisher_exact_f4xact (nrow, irow, ncol, icol, d&
     &sp, fact, tol, f2py_irow_d0, f2py_icol_d0)
      use fisher_exact, only : f4xact
      integer nrow
      integer ncol
      real(kind=8) dsp
      real(kind=8) tol
      integer f2py_irow_d0
      integer f2py_icol_d0
      integer irow(f2py_irow_d0)
      integer icol(f2py_icol_d0)
      real(kind=8) fact(1)
      call f4xact(nrow, irow, ncol, icol, dsp, fact, tol)
      end subroutine f2pywrap_fisher_exact_f4xact
      subroutine f2pywrap_fisher_exact_f5xact (pastp, tol, kval, key, ld&
     &key, ipoin, stp, ldstp, ifrq, npoin, nr, nl, ifreq, itop, ipsh, f2&
     &py_key_d0, f2py_ipoin_d0, f2py_stp_d0, f2py_ifrq_d0, f2py_npoin_d0&
     &, f2py_nr_d0, f2py_nl_d0)
      use fisher_exact, only : f5xact
      real(kind=8) pastp
      real(kind=8) tol
      integer kval
      integer ldkey
      integer ldstp
      integer ifreq
      integer itop
      logical ipsh
      integer f2py_key_d0
      integer f2py_ipoin_d0
      integer f2py_stp_d0
      integer f2py_ifrq_d0
      integer f2py_npoin_d0
      integer f2py_nr_d0
      integer f2py_nl_d0
      integer key(f2py_key_d0)
      integer ipoin(f2py_ipoin_d0)
      real(kind=8) stp(f2py_stp_d0)
      integer ifrq(f2py_ifrq_d0)
      integer npoin(f2py_npoin_d0)
      integer nr(f2py_nr_d0)
      integer nl(f2py_nl_d0)
      call f5xact(pastp, tol, kval, key, ldkey, ipoin, stp, ldstp, ifrq,&
     & npoin, nr, nl, ifreq, itop, ipsh)
      end subroutine f2pywrap_fisher_exact_f5xact
      subroutine f2pywrap_fisher_exact_f6xact (nrow, irow, iflag, kyy, k&
     &ey, ldkey, last, ipn, f2py_irow_d0, f2py_kyy_d0, f2py_key_d0)
      use fisher_exact, only : f6xact
      integer nrow
      integer iflag
      integer ldkey
      integer last
      integer ipn
      integer f2py_irow_d0
      integer f2py_kyy_d0
      integer f2py_key_d0
      integer irow(f2py_irow_d0)
      integer kyy(f2py_kyy_d0)
      integer key(f2py_key_d0)
      call f6xact(nrow, irow, iflag, kyy, key, ldkey, last, ipn)
      end subroutine f2pywrap_fisher_exact_f6xact
      subroutine f2pywrap_fisher_exact_f7xact (nrow, imax, idif, k, ks, &
     &iflag, f2py_imax_d0, f2py_idif_d0)
      use fisher_exact, only : f7xact
      integer nrow
      integer k
      integer ks
      integer iflag
      integer f2py_imax_d0
      integer f2py_idif_d0
      integer imax(f2py_imax_d0)
      integer idif(f2py_idif_d0)
      call f7xact(nrow, imax, idif, k, ks, iflag)
      end subroutine f2pywrap_fisher_exact_f7xact
      subroutine f2pywrap_fisher_exact_f8xact (irow, is, i1, izero, new_&
     &bn, f2py_irow_d0, f2py_new_bn_d0)
      use fisher_exact, only : f8xact
      integer is
      integer i1
      integer izero
      integer f2py_irow_d0
      integer f2py_new_bn_d0
      integer irow(f2py_irow_d0)
      integer new_bn(f2py_new_bn_d0)
      call f8xact(irow, is, i1, izero, new_bn)
      end subroutine f2pywrap_fisher_exact_f8xact
      subroutine f2pywrap_fisher_exact_f9xact (f9xactf2pywrap, n, mm, ir&
     &, fact, f2py_ir_d0)
      use fisher_exact, only : f9xact
      integer n
      integer mm
      integer f2py_ir_d0
      integer ir(f2py_ir_d0)
      real(kind=8) fact(1)
      real(kind=8) f9xactf2pywrap
      f9xactf2pywrap = f9xact(n, mm, ir, fact)
      end subroutine f2pywrap_fisher_exact_f9xact
      subroutine f2pywrap_fisher_exact_f10act (nrow, irow, ncol, icol, v&
     &al, xmin, fact, nd, ne, m, f2py_irow_d0, f2py_icol_d0, f2py_nd_d0,&
     & f2py_ne_d0, f2py_m_d0)
      use fisher_exact, only : f10act
      integer nrow
      integer ncol
      real(kind=8) val
      logical xmin
      integer f2py_irow_d0
      integer f2py_icol_d0
      integer f2py_nd_d0
      integer f2py_ne_d0
      integer f2py_m_d0
      integer irow(f2py_irow_d0)
      integer icol(f2py_icol_d0)
      real(kind=8) fact(1)
      integer nd(f2py_nd_d0)
      integer ne(f2py_ne_d0)
      integer m(f2py_m_d0)
      call f10act(nrow, irow, ncol, icol, val, xmin, fact, nd, ne, m)
      end subroutine f2pywrap_fisher_exact_f10act
      subroutine f2pywrap_fisher_exact_f11act (irow, i1, i2, new_bn, f2p&
     &y_irow_d0, f2py_new_bn_d0)
      use fisher_exact, only : f11act
      integer i1
      integer i2
      integer f2py_irow_d0
      integer f2py_new_bn_d0
      integer irow(f2py_irow_d0)
      integer new_bn(f2py_new_bn_d0)
      call f11act(irow, i1, i2, new_bn)
      end subroutine f2pywrap_fisher_exact_f11act
      subroutine f2pywrap_fisher_exact_isort (n, ix, f2py_ix_d0)
      use fisher_exact, only : isort
      integer n
      integer f2py_ix_d0
      integer ix(f2py_ix_d0)
      call isort(n, ix)
      end subroutine f2pywrap_fisher_exact_isort
      subroutine f2pywrap_fisher_exact_gammad (gammadf2pywrap, x, p)
      use fisher_exact, only : gammad
      real(kind=8) x
      real(kind=8) p
      real(kind=8) gammadf2pywrap
      gammadf2pywrap = gammad(x, p)
      end subroutine f2pywrap_fisher_exact_gammad
      subroutine f2pywrap_fisher_exact_alnorm (alnormf2pywrap, x, upper)
      use fisher_exact, only : alnorm
      real(kind=8) x
      logical upper
      real(kind=8) alnormf2pywrap
      alnormf2pywrap = alnorm(x, upper)
      end subroutine f2pywrap_fisher_exact_alnorm
      subroutine f2pywrap_fisher_exact_lngamma (lngammaf2pywrap, z)
      use fisher_exact, only : lngamma
      real(kind=8) z
      real(kind=8) lngammaf2pywrap
      lngammaf2pywrap = lngamma(z)
      end subroutine f2pywrap_fisher_exact_lngamma
      
      subroutine f2pyinitfisher_exact(f2pysetupfunc)
      interface 
      subroutine f2pywrap_fisher_exact_fexact (nrow, ncol, table, ldtabl&
     &, expect, percnt, emin, wkspace, prt, pre, f2py_table_d0, f2py_tab&
     &le_d1)
      integer nrow
      integer ncol
      integer ldtabl
      real(kind=8) expect
      real(kind=8) percnt
      real(kind=8) emin
      integer wkspace
      real(kind=8) prt
      real(kind=8) pre
      integer f2py_table_d0
      integer f2py_table_d1
      real(kind=8) table(f2py_table_d0,f2py_table_d1)
      end subroutine f2pywrap_fisher_exact_fexact 
      subroutine f2pywrap_fisher_exact_f2xact (nrow, ncol, table, ldtabl&
     &, expect, percnt, emin, prt, pre, ldkey, ldstp, ntotal, ncols, nro&
     &ws, f2py_table_d0, f2py_table_d1)
      integer nrow
      integer ncol
      integer ldtabl
      real(kind=8) expect
      real(kind=8) percnt
      real(kind=8) emin
      real(kind=8) prt
      real(kind=8) pre
      integer ldkey
      integer ldstp
      integer ntotal
      integer ncols
      integer nrows
      integer f2py_table_d0
      integer f2py_table_d1
      real(kind=8) table(f2py_table_d0,f2py_table_d1)
      end subroutine f2pywrap_fisher_exact_f2xact 
      subroutine f2pywrap_fisher_exact_f3xact (nrow, irow, ncol, icol, d&
     &lp, mm, fact, tol, f2py_irow_d0, f2py_icol_d0)
      integer nrow
      integer ncol
      real(kind=8) dlp
      integer mm
      real(kind=8) tol
      integer f2py_irow_d0
      integer f2py_icol_d0
      integer irow(f2py_irow_d0)
      integer icol(f2py_icol_d0)
      real(kind=8) fact(1)
      end subroutine f2pywrap_fisher_exact_f3xact 
      subroutine f2pywrap_fisher_exact_f4xact (nrow, irow, ncol, icol, d&
     &sp, fact, tol, f2py_irow_d0, f2py_icol_d0)
      integer nrow
      integer ncol
      real(kind=8) dsp
      real(kind=8) tol
      integer f2py_irow_d0
      integer f2py_icol_d0
      integer irow(f2py_irow_d0)
      integer icol(f2py_icol_d0)
      real(kind=8) fact(1)
      end subroutine f2pywrap_fisher_exact_f4xact 
      subroutine f2pywrap_fisher_exact_f5xact (pastp, tol, kval, key, ld&
     &key, ipoin, stp, ldstp, ifrq, npoin, nr, nl, ifreq, itop, ipsh, f2&
     &py_key_d0, f2py_ipoin_d0, f2py_stp_d0, f2py_ifrq_d0, f2py_npoin_d0&
     &, f2py_nr_d0, f2py_nl_d0)
      real(kind=8) pastp
      real(kind=8) tol
      integer kval
      integer ldkey
      integer ldstp
      integer ifreq
      integer itop
      logical ipsh
      integer f2py_key_d0
      integer f2py_ipoin_d0
      integer f2py_stp_d0
      integer f2py_ifrq_d0
      integer f2py_npoin_d0
      integer f2py_nr_d0
      integer f2py_nl_d0
      integer key(f2py_key_d0)
      integer ipoin(f2py_ipoin_d0)
      real(kind=8) stp(f2py_stp_d0)
      integer ifrq(f2py_ifrq_d0)
      integer npoin(f2py_npoin_d0)
      integer nr(f2py_nr_d0)
      integer nl(f2py_nl_d0)
      end subroutine f2pywrap_fisher_exact_f5xact 
      subroutine f2pywrap_fisher_exact_f6xact (nrow, irow, iflag, kyy, k&
     &ey, ldkey, last, ipn, f2py_irow_d0, f2py_kyy_d0, f2py_key_d0)
      integer nrow
      integer iflag
      integer ldkey
      integer last
      integer ipn
      integer f2py_irow_d0
      integer f2py_kyy_d0
      integer f2py_key_d0
      integer irow(f2py_irow_d0)
      integer kyy(f2py_kyy_d0)
      integer key(f2py_key_d0)
      end subroutine f2pywrap_fisher_exact_f6xact 
      subroutine f2pywrap_fisher_exact_f7xact (nrow, imax, idif, k, ks, &
     &iflag, f2py_imax_d0, f2py_idif_d0)
      integer nrow
      integer k
      integer ks
      integer iflag
      integer f2py_imax_d0
      integer f2py_idif_d0
      integer imax(f2py_imax_d0)
      integer idif(f2py_idif_d0)
      end subroutine f2pywrap_fisher_exact_f7xact 
      subroutine f2pywrap_fisher_exact_f8xact (irow, is, i1, izero, new_&
     &bn, f2py_irow_d0, f2py_new_bn_d0)
      integer is
      integer i1
      integer izero
      integer f2py_irow_d0
      integer f2py_new_bn_d0
      integer irow(f2py_irow_d0)
      integer new_bn(f2py_new_bn_d0)
      end subroutine f2pywrap_fisher_exact_f8xact 
      subroutine f2pywrap_fisher_exact_f9xact (f9xactf2pywrap, f9xact, n&
     &, mm, ir, fact, f2py_ir_d0)
      real(kind=8) f9xact
      integer n
      integer mm
      integer f2py_ir_d0
      integer ir(f2py_ir_d0)
      real(kind=8) fact(1)
      real(kind=8) f9xactf2pywrap
      end subroutine f2pywrap_fisher_exact_f9xact 
      subroutine f2pywrap_fisher_exact_f10act (nrow, irow, ncol, icol, v&
     &al, xmin, fact, nd, ne, m, f2py_irow_d0, f2py_icol_d0, f2py_nd_d0,&
     & f2py_ne_d0, f2py_m_d0)
      integer nrow
      integer ncol
      real(kind=8) val
      logical xmin
      integer f2py_irow_d0
      integer f2py_icol_d0
      integer f2py_nd_d0
      integer f2py_ne_d0
      integer f2py_m_d0
      integer irow(f2py_irow_d0)
      integer icol(f2py_icol_d0)
      real(kind=8) fact(1)
      integer nd(f2py_nd_d0)
      integer ne(f2py_ne_d0)
      integer m(f2py_m_d0)
      end subroutine f2pywrap_fisher_exact_f10act 
      subroutine f2pywrap_fisher_exact_f11act (irow, i1, i2, new_bn, f2p&
     &y_irow_d0, f2py_new_bn_d0)
      integer i1
      integer i2
      integer f2py_irow_d0
      integer f2py_new_bn_d0
      integer irow(f2py_irow_d0)
      integer new_bn(f2py_new_bn_d0)
      end subroutine f2pywrap_fisher_exact_f11act 
      subroutine f2pywrap_fisher_exact_isort (n, ix, f2py_ix_d0)
      integer n
      integer f2py_ix_d0
      integer ix(f2py_ix_d0)
      end subroutine f2pywrap_fisher_exact_isort 
      subroutine f2pywrap_fisher_exact_gammad (gammadf2pywrap, gammad, x&
     &, p)
      real(kind=8) gammad
      real(kind=8) x
      real(kind=8) p
      real(kind=8) gammadf2pywrap
      end subroutine f2pywrap_fisher_exact_gammad 
      subroutine f2pywrap_fisher_exact_alnorm (alnormf2pywrap, alnorm, x&
     &, upper)
      real(kind=8) alnorm
      real(kind=8) x
      logical upper
      real(kind=8) alnormf2pywrap
      end subroutine f2pywrap_fisher_exact_alnorm 
      subroutine f2pywrap_fisher_exact_lngamma (lngammaf2pywrap, lngamma&
     &, z)
      real(kind=8) lngamma
      real(kind=8) z
      real(kind=8) lngammaf2pywrap
      end subroutine f2pywrap_fisher_exact_lngamma
      end interface
      external f2pysetupfunc
      call f2pysetupfunc(f2pywrap_fisher_exact_fexact,f2pywrap_fisher_ex&
     &act_f2xact,f2pywrap_fisher_exact_f3xact,f2pywrap_fisher_exact_f4xa&
     &ct,f2pywrap_fisher_exact_f5xact,f2pywrap_fisher_exact_f6xact,f2pyw&
     &rap_fisher_exact_f7xact,f2pywrap_fisher_exact_f8xact,f2pywrap_fish&
     &er_exact_f9xact,f2pywrap_fisher_exact_f10act,f2pywrap_fisher_exact&
     &_f11act,f2pywrap_fisher_exact_isort,f2pywrap_fisher_exact_gammad,f&
     &2pywrap_fisher_exact_alnorm,f2pywrap_fisher_exact_lngamma)
      end subroutine f2pyinitfisher_exact

subroutine i4vec_print ( n, a, title )

!*****************************************************************************80
!
!! I4VEC_PRINT prints an I4VEC.
!
!  Discussion:
!
!    An I4VEC is a vector of I4's.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    28 November 2000
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the number of components of the vector.
!
!    Input, integer ( kind = 4 ) A(N), the vector to be printed.
!
!    Input, character ( len = * ) TITLE, a title.
!
  implicit none

  integer ( kind = 4 ) n

  integer ( kind = 4 ) a(n)
  integer ( kind = 4 ) i
  character ( len = * ) title

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) trim ( title )
  write ( *, '(a)' ) ' '
  do i = 1, n
    write ( *, '(2x,i8,2x,i12)' ) i, a(i)
  end do

  return
end
subroutine i4mat_print ( m, n, a, title )

!*****************************************************************************80
!
!! I4MAT_PRINT prints an I4MAT.
!
!  Discussion:
!
!    An I4MAT is a rectangular array of I4 values.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    30 June 2003
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) M, the number of rows in A.
!
!    Input, integer ( kind = 4 ) N, the number of columns in A.
!
!    Input, integer ( kind = 4 ) A(M,N), the matrix to be printed.
!
!    Input, character ( len = * ) TITLE, a title.
!
  implicit none

  integer ( kind = 4 ) m
  integer ( kind = 4 ) n

  integer ( kind = 4 ) a(m,n)
  integer ( kind = 4 ) ihi
  integer ( kind = 4 ) ilo
  integer ( kind = 4 ) jhi
  integer ( kind = 4 ) jlo
  character ( len = * ) title

  ilo = 1
  ihi = m
  jlo = 1
  jhi = n

  call i4mat_print_some ( m, n, a, ilo, jlo, ihi, jhi, title )

  return
end
subroutine i4mat_print_some ( m, n, a, ilo, jlo, ihi, jhi, title )

!*****************************************************************************80
!
!! I4MAT_PRINT_SOME prints some of an I4MAT.
!
!  Discussion:
!
!    An I4MAT is a rectangular array of I4 values.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    04 November 2003
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) M, N, the number of rows and columns.
!
!    Input, integer ( kind = 4 ) A(M,N), an M by N matrix to be printed.
!
!    Input, integer ( kind = 4 ) ILO, JLO, the first row and column to print.
!
!    Input, integer ( kind = 4 ) IHI, JHI, the last row and column to print.
!
!    Input, character ( len = * ) TITLE, a title.
!
  implicit none

  integer ( kind = 4 ), parameter :: incx = 10
  integer ( kind = 4 ) m
  integer ( kind = 4 ) n

  integer ( kind = 4 ) a(m,n)
  character ( len = 8 ) ctemp(incx)
  integer ( kind = 4 ) i
  integer ( kind = 4 ) i2hi
  integer ( kind = 4 ) i2lo
  integer ( kind = 4 ) ihi
  integer ( kind = 4 ) ilo
  integer ( kind = 4 ) inc
  integer ( kind = 4 ) j
  integer ( kind = 4 ) j2
  integer ( kind = 4 ) j2hi
  integer ( kind = 4 ) j2lo
  integer ( kind = 4 ) jhi
  integer ( kind = 4 ) jlo
  character ( len = * ) title

  if ( 0 < len_trim ( title ) ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) trim ( title )
  end if

  do j2lo = max ( jlo, 1 ), min ( jhi, n ), incx

    j2hi = j2lo + incx - 1
    j2hi = min ( j2hi, n )
    j2hi = min ( j2hi, jhi )

    inc = j2hi + 1 - j2lo

    write ( *, '(a)' ) ' '

    do j = j2lo, j2hi
      j2 = j + 1 - j2lo
      write ( ctemp(j2), '(i8)' ) j
    end do

    write ( *, '(''  Col '',10a8)' ) ctemp(1:inc)
    write ( *, '(a)' ) '  Row'
    write ( *, '(a)' ) ' '

    i2lo = max ( ilo, 1 )
    i2hi = min ( ihi, m )

    do i = i2lo, i2hi

      do j2 = 1, inc

        j = j2lo - 1 + j2

        write ( ctemp(j2), '(i8)' ) a(i,j)

      end do

      write ( *, '(i5,1x,10a8)' ) i, ( ctemp(j), j = 1, inc )

    end do

  end do

  return
end
function r8_uniform_01 ( seed )

!*****************************************************************************80
!
!! R8_UNIFORM_01 returns a unit pseudorandom R8.
!
!  Discussion:
!
!    An R8 is a real ( kind = 8 ) value.
!
!    For now, the input quantity SEED is an integer variable.
!
!    This routine implements the recursion
!
!      seed = 16807 * seed mod ( 2^31 - 1 )
!      r8_uniform_01 = seed / ( 2^31 - 1 )
!
!    The integer arithmetic never requires more than 32 bits,
!    including a sign bit.
!
!    If the initial seed is 12345, then the first three computations are
!
!      Input     Output      R8_UNIFORM_01
!      SEED      SEED
!
!         12345   207482415  0.096616
!     207482415  1790989824  0.833995
!    1790989824  2035175616  0.947702
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    05 July 2006
!
!  Author:
!
!    John Burkardt
!
!  Reference:
!
!    Paul Bratley, Bennett Fox, Linus Schrage,
!    A Guide to Simulation,
!    Springer Verlag, pages 201-202, 1983.
!
!    Pierre L'Ecuyer,
!    Random Number Generation,
!    in Handbook of Simulation,
!    edited by Jerry Banks,
!    Wiley Interscience, page 95, 1998.
!
!    Bennett Fox,
!    Algorithm 647:
!    Implementation and Relative Efficiency of Quasirandom
!    Sequence Generators,
!    ACM Transactions on Mathematical Software,
!    Volume 12, Number 4, pages 362-376, 1986.
!
!    Peter Lewis, Allen Goodman, James Miller
!    A Pseudo-Random Number Generator for the System/360,
!    IBM Systems Journal,
!    Volume 8, pages 136-143, 1969.
!
!  Parameters:
!
!    Input/output, integer ( kind = 4 ) SEED, the "seed" value, which should
!    NOT be 0. On output, SEED has been updated.
!
!    Output, real ( kind = 8 ) R8_UNIFORM_01, a new pseudorandom variate,
!    strictly between 0 and 1.
!
  implicit none

  integer ( kind = 4 ), parameter :: i4_huge = 2147483647
  integer ( kind = 4 ) k
  real ( kind = 8 ) r8_uniform_01
  integer ( kind = 4 ) seed

  if ( seed == 0 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'R8_UNIFORM_01 - Fatal error!'
    write ( *, '(a)' ) '  Input value of SEED = 0.'
    stop
  end if

  k = seed / 127773

  seed = 16807 * ( seed - k * 127773 ) - k * 2836

  if ( seed < 0 ) then
    seed = seed + i4_huge
  end if
!
!  Although SEED can be represented exactly as a 32 bit integer,
!  it generally cannot be represented exactly as a 32 bit real number!
!
  r8_uniform_01 = real ( seed, kind = 8 ) * 4.656612875D-10

  return
end
subroutine rcont2 ( nrow, ncol, nrowt, ncolt, maxtot, key, seed, fact, matrix, ierror )

!*****************************************************************************80
!
!! RCONT2 constructs a random two-way contingency table with given sums.
!
!  Discussion:
!
!    It is possible to specify row and column sum vectors which
!    correspond to no table at all.  As far as I can see, this routine does
!    not detect such a case.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    10 March 2009
!
!  Author:
!
!    Original FORTRAN77 version by WM Patefield.
!    FORTRAN90 version by John Burkardt.
!
!  Reference:
!
!    WM Patefield,
!    Algorithm AS 159:
!    An Efficient Method of Generating RXC Tables with
!    Given Row and Column Totals,
!    Applied Statistics,
!    Volume 30, Number 1, 1981, pages 91-97.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) NROW, NCOL, the number of rows and columns
!    in the table.  NROW and NCOL must each be at least 2.
!
!    Input, integer ( kind = 4 ) NROWT(NROW), NCOLT(NCOL), the row and column
!    sums.  Each entry must be positive.
!
!    Input, integer ( kind = 4 ) MAXTOT, the max total size for the matrix 
!    column sum.
!
!    Input/output, logical KEY, a flag that indicates whether data has
!    been initialized for this problem.  Set KEY = .FALSE. before the first
!    call.
!
!    Input/output, integer ( kind = 4 ) SEED, a seed for the random number
!    generator.
!
!    Input/output, real ( kind = 4 ) fact, contains the log factorials
!
!    Output, integer ( kind = 4 ) MATRIX(NROW,NCOL), the matrix.
!
!    Output, integer ( kind = 4 ) IERROR, an error flag, which is returned
!    as 0 if no error occurred.
!
  implicit none


  integer ( kind = 4 ) ncol
  integer ( kind = 4 ) nrow
  integer ( kind = 4 ) maxtot
  real ( kind = 8 ), intent(inout) :: fact(maxtot+1)

  logical done1
  logical done2
  integer ( kind = 4 ) i
  integer ( kind = 4 ) ia
  integer ( kind = 4 ) iap
  integer ( kind = 4 ) ib
  integer ( kind = 4 ) ic
  integer ( kind = 4 ) id
  integer ( kind = 4 ) idp
  integer ( kind = 4 ) ie
  integer ( kind = 4 ) , intent(inout) :: ierror
  integer ( kind = 4 ) igp
  integer ( kind = 4 ) ihp
  integer ( kind = 4 ) ii
  integer ( kind = 4 ) iip
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jc
  integer ( kind = 4 ) jwork(ncol)
  logical, intent(inout) :: key
  integer ( kind = 4 ) l
  logical lsm
  logical lsp
  integer ( kind = 4 ) m
  integer ( kind = 4 ), intent(inout) :: matrix(nrow,ncol)
  integer ( kind = 4 ) ncolt(ncol)
  integer ( kind = 4 ) nll
  integer ( kind = 4 ) nlm
  integer ( kind = 4 ) nlmp
  integer ( kind = 4 ) nrowt(nrow)
  integer ( kind = 4 ) nrowtl
  integer ( kind = 4 ), save :: ntotal = 0
  real ( kind = 8 ) r
  real ( kind = 8 ) r8_uniform_01
  integer ( kind = 4 ), intent(inout) :: seed
  real ( kind = 8 ) sumprb
  real ( kind = 8 ) x
  real ( kind = 8 ) y

  ierror = 0
!
!  On user's signal, set up the factorial table.
!
  if ( .not. key ) then

    key = .true.

    if ( nrow <= 1 ) then
      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'RCONT - Fatal error!'
      write ( *, '(a)' ) '  Input number of rows is less than 2.'
      ierror = 1
      return
    end if

    if ( ncol <= 1 ) then
      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'RCONT - Fatal error!'
      write ( *, '(a)' ) '  The number of columns is less than 2.'
      ierror = 2
      return
    end if

    do i = 1, nrow
      if ( nrowt(i) <= 0 ) then
        write ( *, '(a)' ) ' '
        write ( *, '(a)' ) 'RCONT - Fatal error!'
        write ( *, '(a)' ) '  An entry in the row sum vector is not positive.'
        ierror = 3
        return
      end if
    end do

    do j = 1, ncol
      if ( ncolt(j) <= 0 ) then
        write ( *, '(a)' ) ' '
        write ( *, '(a)' ) 'RCONT - Fatal error!'
        write ( *, '(a)' ) &
         '  An entry in the column sum vector is not positive.'
        ierror = 4
        return
      end if
    end do

    if ( sum ( ncolt(1:ncol) ) /= sum ( nrowt(1:nrow) ) ) then
      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'RCONT - Fatal error!'
      write ( *, '(a)' ) &
        '  The row and column sum vectors do not have the same sum.'
      ierror = 6
      return
    end if

    ntotal = sum ( ncolt(1:ncol) )

    if ( maxtot < ntotal ) then
      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'RCONT - Fatal error!'
      write ( *, '(a)' ) &
        '  The sum of the column sum vector entries is too large.'
      ierror = 5
      return
    end if
!
!  Calculate log-factorials.
!
    x = 0.0D+00
    fact(1) = 0.0D+00
    do i = 1, ntotal
      x = x + log ( real ( i, kind = 8 ) )
      fact(i+1) = x
    end do

  end if
!
!  Construct a random matrix.
!
  jwork(1:ncol-1) = ncolt(1:ncol-1)

  jc = ntotal

  do l = 1, nrow - 1

    nrowtl = nrowt(l)
    ia = nrowtl
    ic = jc
    jc = jc - nrowtl

    do m = 1, ncol - 1

      id = jwork(m)
      ie = ic
      ic = ic - id
      ib = ie - ia
      ii = ib - id
!
!  Test for zero entries in matrix.
!
      if ( ie == 0 ) then
        ia = 0
        matrix(l,m:ncol) = 0
        exit
      end if
!
!  Generate a pseudo-random number.
!
      r = r8_uniform_01 ( seed )
!
!  Compute the conditional expected value of MATRIX(L,M).
!
      done1 = .false.

      do

        nlm = int ( &
          real ( ia * id, kind = 8 ) / real ( ie , kind = 8 ) + 0.5D+00 )

        iap = ia + 1
        idp = id + 1
        igp = idp - nlm
        ihp = iap - nlm
        nlmp = nlm + 1
        iip = ii + nlmp
        x = exp ( fact(iap) + fact(ib+1) + fact(ic+1) + fact(idp) - &
          fact(ie+1) - fact(nlmp) - fact(igp) - fact(ihp) - fact(iip) )

        if ( r <= x ) then
          exit
        end if

        sumprb = x
        y = x
        nll = nlm
        lsp = .false.
        lsm = .false.
!
!  Increment entry in row L, column M.
!
        do while ( .not. lsp )

          j = ( id - nlm ) * ( ia - nlm )

          if ( j == 0 ) then

            lsp = .true.

          else

            nlm = nlm + 1
            x = x * real ( j, kind = 8 ) &
              / real ( nlm * ( ii + nlm ), kind = 8 )
            sumprb = sumprb + x

            if ( r <= sumprb ) then
              done1 = .true.
              exit
            end if

          end if

          done2 = .false.

          do while ( .not. lsm )
!
!  Decrement the entry in row L, column M.
!
            j = nll * ( ii + nll )

            if ( j == 0 ) then
              lsm = .true.
              exit
            end if

            nll = nll - 1
            y = y * real ( j, kind = 8 ) &
              / real ( ( id - nll ) * ( ia - nll ), kind = 8 )
            sumprb = sumprb + y

            if ( r <= sumprb ) then
              nlm = nll
              done2 = .true.
              exit
            end if

            if ( .not. lsp ) then
              exit
            end if

          end do

          if ( done2 ) then
            exit
          end if

        end do

        if ( done1 ) then
          exit
        end if

        if ( done2 ) then
          exit
        end if

        r = r8_uniform_01 ( seed )
        r = sumprb * r

      end do

      matrix(l,m) = nlm
      ia = ia - nlm
      jwork(m) = jwork(m) - nlm

    end do

    matrix(l,ncol) = ia

  end do
!
!  Compute the last row.
!
  matrix(nrow,1:ncol-1) = jwork(1:ncol-1)
  matrix(nrow,ncol) = ib - matrix(nrow,ncol-1)

  return
end
subroutine timestamp ( )

!*****************************************************************************80
!
!! TIMESTAMP prints the current YMDHMS date as a time stamp.
!
!  Example:
!
!    31 May 2001   9:45:54.872 AM
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    18 May 2013
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    None
!
  implicit none

  character ( len = 8 ) ampm
  integer ( kind = 4 ) d
  integer ( kind = 4 ) h
  integer ( kind = 4 ) m
  integer ( kind = 4 ) mm
  character ( len = 9 ), parameter, dimension(12) :: month = (/ &
    'January  ', 'February ', 'March    ', 'April    ', &
    'May      ', 'June     ', 'July     ', 'August   ', &
    'September', 'October  ', 'November ', 'December ' /)
  integer ( kind = 4 ) n
  integer ( kind = 4 ) s
  integer ( kind = 4 ) values(8)
  integer ( kind = 4 ) y

  call date_and_time ( values = values )

  y = values(1)
  m = values(2)
  d = values(3)
  h = values(5)
  n = values(6)
  s = values(7)
  mm = values(8)

  if ( h < 12 ) then
    ampm = 'AM'
  else if ( h == 12 ) then
    if ( n == 0 .and. s == 0 ) then
      ampm = 'Noon'
    else
      ampm = 'PM'
    end if
  else
    h = h - 12
    if ( h < 12 ) then
      ampm = 'PM'
    else if ( h == 12 ) then
      if ( n == 0 .and. s == 0 ) then
        ampm = 'Midnight'
      else
        ampm = 'AM'
      end if
    end if
  end if

  write ( *, '(i2,1x,a,1x,i4,2x,i2,a1,i2.2,a1,i2.2,a1,i3.3,1x,a)' ) &
    d, trim ( month(m) ), y, h, ':', n, ':', s, '.', mm, trim ( ampm )

  return
end

subroutine enum ( m, n, rowsum, colsum, eval, ifault )

!*****************************************************************************80
!
!! ENUM generates contingency tables with given shape and row and column sums.
!
!  Discussion:
!
!   The routine enumerates all M by N contingency tables with given row 
!   and column totals, and calculates the hypergeometric probability of 
!   each table.
!
!   For tables having two or more row sums repeated, equivalent
!   tables differing only by a row permutation are not separately
!   enumerated.  A representative of each equivalence class is enumerated
!   and the multiplicity of each class calculated.
!
!   For each table enumerated, subroutine EVAL is called to carry out
!   calculations on the table.
!
!   Note that the entries in the column sum and row sum vectors will
!   be (implicitly) sorted into ascending order, and results will be 
!   returned as though these orderings were being used!
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    05 February 2008
!
!  Author:
!
!    Original FORTRAN77 version by Ian Saunders.
!    FORTRAN90 version by John Burkardt.
!
!  Reference:
!
!    Ian Saunders,
!    Algorithm AS 205,
!    Enumeration of R x C Tables with Repeated Row Totals,
!    Applied Statistics,
!    Volume 33, Number 3, 1984, pages 340-352. 
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) M, the number of rows.
!
!    Input, integer ( kind = 4 ) N, the number of columns.
!
!    Input, integer ( kind = 4 ) ROWSUM(M), the row sums.
!
!    Input, integer ( kind = 4 ) COLSUM(N), the column sums.
!
!    Input, external EVAL, the name of the user supplied routine
!    that will be called each time a new table is determined.
!    The routine has the form:
!      subroutine eval ( iflag, table, m, n, rowsum, colsum, prob, mult )
!    See the dummy version of EVAL for an explanation of the meaning
!    of the arguments.
!
!    Output, integer ( kind = 4 ) IFAULT, error flag.
!    0, no error occurred.
!
!  Local parameters:
!
!    Local, integer ( kind = 4 ) BOUND(M_MAX,M_MAX).  BOUND(I,J) is the
!    current upper bound on TABLE2(I,J) to satisfy row and column totals.
!
!    Local, integer ( kind = 4 ) M_MAX, the maximum dimension of TABLE2.
!
!    Local, integer ( kind = 4 ) MULT2(M_MAX), MULT2(I) is the maximum number 
!    of equivalent tables given the first I rows.
!
!    Local, integer ( kind = 4 ) NTOTAL, the total of the table entries.
!
!    Local, real ( kind = 8 ) PROB2(M_MAX,M_MAX), the partial sum of terms 
!    in log(p).
!
!    Local, integer ( kind = 4 ) REPS(M_MAX), the number of previous rows equal 
!    to row I.
!
!    Local, logical REPT(M_MAX), is true if row totals ROWSUM(I) and N(I-1) 
!    are equal.
!
!    Local, integer ( kind = 4 ) TABLE2(M_MAX,M_MAX), the current table.
!
!    Local, integer ( kind = 4 ) TOTAL_MAX, the maximum number of observations.
!
!    Local, integer ( kind = 4 ) Z(M_MAX), the lower bound on the sum of 
!    entries used by algorithm C.
!
  implicit none

  integer ( kind = 4 ) m
  integer ( kind = 4 ), parameter :: m_max = 10
  integer ( kind = 4 ) n
  integer ( kind = 4 ), parameter :: total_max = 201

  integer ( kind = 4 ) bound(m_max,m_max)
  integer ( kind = 4 ) colsum(n)
  integer ( kind = 4 ) colsum2(m_max)
  external eval
  real ( kind = 8 ) factlm(total_max+1)
  real ( kind = 8 ) flogm(total_max+1)
  integer ( kind = 4 ) i
  logical ieqim
  integer ( kind = 4 ) ifault
  integer ( kind = 4 ) iflag
  integer ( kind = 4 ) ii
  integer ( kind = 4 ) iim
  integer ( kind = 4 ) iip
  integer ( kind = 4 ) ij
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jj
  integer ( kind = 4 ) jjj
  integer ( kind = 4 ) jjm
  integer ( kind = 4 ) jkeep
  integer ( kind = 4 ) jnext
  integer ( kind = 4 ) k
  integer ( kind = 4 ) left
  integer ( kind = 4 ) m2
  integer ( kind = 4 ) maxrc
  integer ( kind = 4 ) mtotal
  integer ( kind = 4 ) mult
  integer ( kind = 4 ) mult2(m_max)
  integer ( kind = 4 ) multc
  integer ( kind = 4 ) multr
  integer ( kind = 4 ) n2
  integer ( kind = 4 ) ntotal
  real ( kind = 8 ) prob
  real ( kind = 8 ) prob0
  real ( kind = 8 ) prob2(m_max,m_max)
  integer ( kind = 4 ) reps(m_max)
  integer ( kind = 4 ) repsc
  integer ( kind = 4 ) repsr
  logical rept(m_max)
  logical reptc(m_max)
  integer ( kind = 4 ) rowbnd
  integer ( kind = 4 ) rsum
  integer ( kind = 4 ) rowsum(m)
  integer ( kind = 4 ) rowsum2(m_max)
  integer ( kind = 4 ) table(m,n)
  integer ( kind = 4 ) table2(m_max,m_max)
  integer ( kind = 4 ) z(m_max)
!
!  Check the input values.
!
  ifault = 0

  if ( m <= 0 .or. m_max < m ) then
    ifault = 1
    return
  end if

  if ( n <= 0 .or. m_max < n ) then
    ifault = 1
    return
  end if

  ntotal = 0
  do i = 1, m
    if ( rowsum(i) <= 0 ) then
      ifault = 3
      return
    end if
    ntotal = ntotal + rowsum(i)
  end do

  mtotal = 0
  do j = 1, n
    if ( colsum(j) <= 0 ) then
      ifault = 3
      return
    end if
    mtotal = mtotal + colsum(j)
  end do

  if ( mtotal /= ntotal ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'ENUM - Fatal error!'
    write ( *, '(a)' ) '  Row and column sums are not equal.'
    write ( *, '(a,i8)' ) '  Row sum =    ', ntotal
    write ( *, '(a,i8)' ) '  Column sum = ', mtotal
    ifault = 2
    return
  end if

  if ( total_max < ntotal ) then
    ifault = 4
    return
  end if
!
!  Copy the parameters.
!
  m2 = m
  n2 = n
  rowsum2(1:m) = rowsum(1:m)
  colsum2(1:n) = colsum(1:n)
!
!  The first call to EVAL is simply to allow EVAL to initialize.
!
  iflag = 1
  prob = 0.0D+00
  mult = 0
  table(1:m,1:n) = 0
  call eval ( iflag, table, m, n, rowsum, colsum, prob, mult ) 
!
!  Initialize 
!    flogm(k) = log(k-1), 
!    factlm(k) = log( (k-1)! )
!
  flogm(1) = 0.0D+00
  factlm(1) = 0.0D+00
  do k = 1, ntotal
    flogm(k+1) = log ( real ( k, kind = 8 ) )
    factlm(k+1) = factlm(k) + flogm(k+1)
  end do
!
!  Sort the rows and columns into ascending order.
!
! do i = 1, m2-1
!   do ii = i+1, m2
!     if ( rowsum2(ii) < rowsum2(i) ) then
!       call i4_swap ( rowsum2(i), rowsum2(ii) )
!     end if
!   end do
! end do

! do j = 1, n2-1
!   do jj = j+1, n2
!     if ( colsum2(jj) < colsum2(j) ) then
!       call i4_swap ( colsum2(j), colsum2(jj) )
!     end if
!   end do
! end do
!
!  Calculate the multiplicities of rows and columns.
!
!  reptc(j) = .true. if columns J and J-1 have the same total.
!  rept(i)  = .true. if rows I and I-1 have the same total.
!
  multc = 1.0D+00
  repsc = 1.0D+00
  reptc(1) = .false.

  do j = 2, n2
    reptc(j) = ( colsum2(j) == colsum2(j-1) )
    if ( reptc(j) ) then
      repsc = repsc + 1.0D+00
      multc = multc * repsc
    else
      repsc = 1.0D+00
    end if
  end do

  multr = 1.0D+00
  repsr = 1.0D+00
  rept(1) = .false.

  do i = 2, m2

    rept(i) = ( rowsum2(i) == rowsum2(i-1) )

    if ( rept(i) ) then
      repsr = repsr + 1.0D+00
      multr = multr * repsr
    else
      repsr = 1.0D+00
    end if

  end do
!
!  If column multiplicity exceeds row multiplicity, transpose the table.
!
  if ( multr < multc ) then

    maxrc = max ( m2, n2 )
    do ij = 1, maxrc
      call i4_swap ( rowsum2(ij), colsum2(ij) )
    end do

    call i4_swap ( m2, n2 )
    rept(1:m2) = reptc(1:m2)
    multr = multc

  end if
!
!  Set up the initial table.
!
!  Maximum multiplicity.
!
  mult2(1) = multr
  reps(1) = 1.0D+00
!
!  Constant term in probability.
!
  prob0 = - factlm(ntotal+1)

  do i = 1, m2
    ii = rowsum2(i)
    prob0 = prob0 + factlm(ii+1)
  end do

  do j = 1, n2
    jj = colsum2(j)
    prob0 = prob0 + factlm(jj+1)
  end do
!
!  Calculate bounds on row 1.
!
  bound(1,1:n2) = colsum2(1:n2)
!
!  For each I, find the greatest I-th row satisfying bounds.
!
  do i = 1, m2

    if ( i /= 1 ) then
      prob0 = prob2(i-1,n2)
    end if

    left = rowsum2(i)
!
!  Elements of row I:
!
    ieqim = rept(i)

    do j = 1, n2 - 1

      ij = min ( left, bound(i,j) )
      table2(i,j) = ij

      if ( j == 1 ) then
        prob2(i,j) = prob0 - factlm(ij+1)
      else
        prob2(i,j) = prob2(i,j-1) - factlm(ij+1)
      end if

      left = left - table2(i,j)

      if ( i < m2 ) then
        bound(i+1,j) = bound(i,j) - table2(i,j)
      end if

      if ( left == 0 ) then

        do jj = j+1, n2
          table2(i,jj) = 0
          prob2(i,jj) = prob2(i,jj-1)
          bound(i+1,jj) = bound(i,jj)
        end do

        exit

      end if

      if ( ieqim ) then
        ieqim = table2(i,j) == table2(i-1,j)
      end if

    end do

    if ( left /= 0 ) then
      table2(i,n2) = left
      prob2(i,n2) = prob2(i,n2-1) - factlm(left+1)
      if ( i < m2 ) then
         bound(i+1,n2) = bound(i,n2) - left
      end if

    end if

    if ( 1 < i ) then

      mult2(i) = mult2(i-1)
      reps(i) = 1.0D+00

      if ( ieqim ) then
        reps(i) = reps(i-1) + 1.0D+00
        mult2(i) = mult2(i) / reps(i)
      end if

    end if

  end do
!
!  Call EVAL for the first table.
!
  iflag = 2
  prob = prob2(m2,n2)
  mult = mult2(m2)

  if ( m == m2 .and. n == n2 ) then
    table(1:m,1:n) = table2(1:m2,1:n2)
  else
    table(1:m,1:n) = transpose ( table2(1:m2,1:n2) )
  end if

  call eval ( iflag, table, m, n, rowsum, colsum, prob, mult ) 
!
!  Enumerate the remaining tables.
!
!  Start of main loop.
!
  do
   
    i = m2

210 continue

    i = i - 1
!
!  If I = 0, no more tables are possible.
!
    if ( i == 0 ) then
      exit
    end if

    j = n2 - 1
    left = table2(i,n2)
    rowbnd = bound(i,n2)
!
!  Try to decrease element (I,J).
!
    do
!
!  Decrease element (I,J).
!
      if ( 0 < table2(i,j) .and. left < rowbnd ) then

        ij = table2(i,j)
        prob2(i,j) = prob2(i,j) + flogm(ij+1)
        table2(i,j) = table2(i,j) - 1
        bound(i+1,j) = bound(i+1,j) + 1
!
!  If row I was the same as row I-1, it is no longer.
!
        if ( reps(i) /= 1.0D+00 ) then
          reps(i) = 1.0D+00
          mult2(i) = mult2(i-1)
        end if
!
!  Complete row I with the largest possible values.
!
        ii = i
        iip = ii + 1
        iim = ii - 1
        jnext = j + 1
        left = left + 1
        go to 380
!
!  Element (I,J) cannot be decreased.  Try (I,J-1).
!
      else if ( j <= 1 ) then

        exit

      else

        left = left + table2(i,j)
        rowbnd = rowbnd + bound(i,j)
        j = j - 1

      end if

    end do

    go to 210
!
!  Fill up the remaining rows.
!
300 continue

    ii = ii + 1
!
!  The last row is treated separately.
!
    if ( ii == m2 ) then
      go to 400
    end if

    iip = ii + 1
    iim = ii - 1
!
!  Row total ROWSUM2(II) is not a repeat.  Make row II as large as possible.
!
    if ( .not. rept(ii) ) then
      left = rowsum2(ii)
      jnext = 1
      go to 380
    end if
!
!  Repeated row totals.
!
!   (i) if row II-1 satisfies the bounds on row II repeat it
!
310 continue
  
    do j = 1, n2

      if ( bound(ii,j) < table2(iim,j) ) then
        go to 330
      end if

      ij = table2(iim,j)
      table2(ii,j) = ij
      bound(iip,j) = bound(ii,j) - table2(ii,j)

      if ( j == 1 ) then
        prob2(ii,j) = prob2(iim,n2) - factlm(ij+1)
      else
        prob2(ii,j) = prob2(ii,j-1) - factlm(ij+1)
      end if

    end do
!
!  Row II is a repeat of row II-1.
!
    reps(ii) = reps(iim) + 1.0D+00
    mult2(ii) = mult2(iim) / reps(ii)
    go to 300
!
!  Element J of row II-1 was too big.
!
!  Construct the sequence z(j) of lower bounds
!
330 continue
!
!  If J=1 the bounds are satisfied automatically.
!
    if ( j == 1 ) then
      ij = bound(ii,1)
      table2(ii,1) = ij
      prob2(ii,1) = prob2(iim,n2) - factlm(ij+1)
      jnext = 2
      left = rowsum2(ii) - table2(ii,1)
      bound(iip,1) = 0
      go to 380
    end if

    z(j) = rowsum2(ii)

    do jj = j+1, n2
      z(j) = z(j) - bound(ii,jj)
    end do

    do jjm = 1, j-1
      jj = j - jjm
      z(jj) = z(jj+1) - bound(ii,jj+1)
    end do
!
!  (ii) if the cumulative totals of row II-1 all exceed the bounds Z(J),
!  make element (II,J) equal to its bound.
!
    rsum = 0
    jkeep = 0

    do jj = 1, j-1

      rsum = rsum + table2(iim,jj)
!
!  (III) the cumulative sums violate the bounds.
!  If no element of row II-1 can be changed to satisfy the bounds,
!  then no suitable row II is possible.
!  In that case go back and try decreasing row II-1.
!
      if ( rsum < z(jj) ) then

        if ( jkeep == 0 ) then
          i = ii
          go to 210
        end if
!
!  Element (II,JKEEP) can be decreased.
!
        bound(iip,jkeep) = bound(iip,jkeep) + 1
        ij = table2(ii,jkeep)
        prob2(ii,jkeep) = prob2(ii,jkeep) + flogm(ij+1)
        table2(ii,jkeep) = table2(ii,jkeep) - 1
!
!  Complete the row.
!
        jnext = jkeep + 1
        left = rowsum2(ii)

        do jjj = 1, jkeep
          left = left - table2(ii,jjj)
        end do

        go to 380

      end  if

      if ( z(jj) < rsum .and. 0 < table2(iim,jj) ) then
        jkeep = jj
      end if

    end do

    table2(ii,j) = bound(ii,j)
    bound(iip,j) = 0
    ij = table2(ii,j)
    prob2(ii,j) = prob2(ii,j-1) - factlm(ij+1)
    reps(ii) = 1.0D+00
    mult2(ii) = mult2(iim)
!
!  Complete row II with the largest possible elements.
!
    jnext = j + 1
    left = rowsum2(ii)
    do jj = 1, j
      left = left - table2(ii,jj)
    end do
!
!  Row II is complete up to element JNEXT-1.
!  Make the remaining elements as large as possible.
!  This section of code is used for every row, repeated or not.
!
380 continue

    do j = jnext, n2 - 1

      table2(ii,j) = min ( left, bound(ii,j) )
      left = left - table2(ii,j)
      bound(iip,j) = bound(ii,j) - table2(ii,j)
      ij = table2(ii,j)

      if ( j == 1 ) then
        prob2(ii,j) = prob2(iim,n2) - factlm(ij+1)
      else
        prob2(ii,j) = prob2(ii,j-1) - factlm(ij+1)
      end if

      if ( left == 0 ) then
        do jj = j+1, n2
          table2(ii,jj) = 0
          prob2(ii,jj) = prob2(ii,jj-1)
          bound(iip,jj) = bound(ii,jj)
        end do
        exit
      end if

    end do

    if ( left .ne. 0 ) then
      table2(ii,n2) = left
      prob2(ii,n2) = prob2(ii,n2-1) - factlm(left+1)
      bound(iip,n2) = bound(ii,n2) - left
    end if

    reps(ii) = 1.0D+00

    if ( 1 < ii ) then
      mult2(ii) = mult2(iim)
    end if

    go to 300
!
!  The final row.
!
400 continue
!
!  If not a repeat, set row M2 equal to its bounds.
!
    if ( .not. rept(m2) ) then

      ij = bound(m2,1)
      table2(m2,1) = ij
      prob2(m2,1) = prob2(m2-1,n2) - factlm(ij+1)

      do j = 2, n2
        ij = bound(m2,j)
        table2(m2,j) = ij
        prob2(m2,j) = prob2(m2,j-1) - factlm(ij+1)
      end do

      mult2(m2) = mult2(m2-1)
      go to 500

    end if
!
!  Row total M2 is a repeat - ensure that it is less than row M2-1.
!
    do j = 1, n2
!
!  If row M2 would be bigger than row M2-1, go back and try
!  decreasing row M2-2.
!
      if ( table2(m2-1,j) < bound(m2,j) ) then
        i = m2 - 1
        go to 210
      end if

      ij = bound(m2,j)
      table2(m2,j) = ij

      if ( j == 1 ) then
        prob2(m2,j) = prob2(m2-1,n2) - factlm(ij+1)
      else
        prob2(m2,j) = prob2(m2,j-1) - factlm(ij+1)
      end if
!
!  Row M2 is already less then row M2-1, so no more checks are needed.
!
      if ( table2(m2,j) /= table2(m2-1,j) ) then

        do jj = j + 1, n2
          ij = bound(m2,jj)
          table2(m2,jj) = ij
          prob2(m2,jj) = prob2(m2,jj-1) - factlm(ij+1)
        end do

        mult2(m2) = mult2(m2-1)
        go to 500

      end if

    end do
!
!  Row M2 is a repeat of row M2-1.
!
    reps(m2) = reps(m2-1) + 1.0D+00
    mult2(m2) = mult2(m2-1) / reps(m2)
!
!  The table is complete.
!
500 continue

    iflag = 2
    prob = prob2(m2,n2)
    mult = mult2(m2)

    if ( m == m2 .and. n == n2 ) then
      table(1:m,1:n) = table2(1:m2,1:n2)
    else
      table(1:m,1:n) = transpose ( table2(1:m2,1:n2) )
    end if

    call eval ( iflag, table, m, n, rowsum, colsum, prob, mult )

  end do

  iflag = 3
  prob = 0.0D+00
  mult = 0
  table(1:m,1:n) = 0
  call eval ( iflag, table, m, n, rowsum, colsum, prob, mult ) 

  return
end
subroutine eval ( iflag, table, m, n, rowsum, colsum, prob, mult )

!*****************************************************************************80
!
!! EVAL is called by ENUM every time a new contingency table is determined.
!
!  Discussion:
!
!    This is a dummy version of the routine.
!
!    The user might wish to print out each contingency table, or collect
!    some statistics.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    27 November 2006
!
!  Author:
!
!    John Burkardt
!
!  Reference:
!
!    Ian Saunders,
!    Algorithm AS 205,
!    Enumeration of R x C Tables with Repeated Row Totals,
!    Applied Statistics,
!    Volume 33, Number 3, pages 340-352, 1984. 
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) IFLAG, input flag.
!    1, this is the first call.  No table is input.
!    2, this is a call with a new table.
!    3, this is the last call.  No table is input.
!
!    Input, integer ( kind = 4 ) TABLE(M,N), the current contingency table.
!
!    Input, integer ( kind = 4 ) M, the number of rows.
!
!    Input, integer ( kind = 4 ) N, the number of columns.
!
!    Input, integer ( kind = 4 ) ROWSUM(M), the row sums.
!
!    Input, integer ( kind = 4 ) COLSUM(N), the column sums.
!
!    Input, real ( kind = 8 ) PROB, the logarithm of the hypergeometric 
!    probability of this table.
!
!    Input, integer ( kind = 4 ) MULT, the multiplicity of this table, that is,
!    the number of different tables that still have the same set of
!    entries, but differ by a permutation of some rows and columns.
!
  implicit none

  integer ( kind = 4 ) m
  integer ( kind = 4 ) n

  integer ( kind = 4 ) colsum(n)
  integer ( kind = 4 ), save :: count1 = 0
  integer ( kind = 4 ), save :: count2 = 0
  integer ( kind = 4 ) iflag
  integer ( kind = 4 ) mult
  real ( kind = 8 ) prob
  real ( kind = 8 ), save :: psum = 0.0D+00
  integer ( kind = 4 ) rowsum(m)
  integer ( kind = 4 ) table(m,n)
!
!  First call, no table, initialize.
!
  if ( iflag == 1 ) then

    count1 = 0
    count2 = 0
    psum = 0.0D+00
!
!  Call with a new table.
!
  else if ( iflag == 2 ) then

    count1 = count1 + 1
    count2 = count2 + mult 
    psum = psum + real ( mult, kind = 8 ) * exp ( prob )

    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'EVAL:'
    write ( *, '(i3,i3,g14.6)' ) count1, mult, prob

    call i4mat_print ( m, n, table, '  Table' )
!
!  Last call, no table.
!
  else if ( iflag == 3 ) then

    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'EVAL summary'
    write ( *, '(a,i8)' ) '  Number of cases (ignoring multiplicity):', count1
    write ( *, '(a,i8)' ) '  Number of cases (allowing multiplicity):', count2
    write ( *, '(a,g14.6)' ) '  Probability sum = ', psum

  end if

  return
end
subroutine i4_swap ( i, j )

!*****************************************************************************80
!
!! I4_SWAP swaps two I4's.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    30 November 1998
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input/output, integer ( kind = 4 ) I, J.  On output, the values of I and
!    J have been interchanged.
!
  implicit none

  integer ( kind = 4 ) i
  integer ( kind = 4 ) j
  integer ( kind = 4 ) k

  k = i
  i = j
  j = k

  return
end
subroutine i4mat_print ( m, n, a, title )

!*****************************************************************************80
!
!! I4MAT_PRINT prints an I4MAT.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    08 May 2000
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) M, the number of rows in A.
!
!    Input, integer ( kind = 4 ) N, the number of columns in A.
!
!    Input, integer ( kind = 4 ) A(M,N), the matrix to be printed.
!
!    Input, character ( len = * ) TITLE, a title.
!
  implicit none

  integer ( kind = 4 ) m
  integer ( kind = 4 ) n

  integer ( kind = 4 ) a(m,n)
  integer ( kind = 4 ) i
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jhi
  integer ( kind = 4 ) jlo
  character ( len = * ) title

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) trim ( title )

  do jlo = 1, n, 10
    jhi = min ( jlo + 9, n )
    write ( *, '(a)' ) ' '
    write ( *, '(6x,10(i7))' ) ( j, j = jlo, jhi )
    write ( *, '(a)' ) ' '
    do i = 1, m
      write ( *, '(i6,10i7)' ) i, a(i,jlo:jhi)
    end do
  end do

  return
end
subroutine i4vec_print ( n, a, title )

!*****************************************************************************80
!
!! I4VEC_PRINT prints an I4VEC.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license. 
!
!  Modified:
!
!    16 December 1999
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the number of components of the vector.
!
!    Input, integer ( kind = 4 ) A(N), the vector to be printed.
!
!    Input, character ( len = * ) TITLE, a title.
!
  implicit none

  integer ( kind = 4 ) n

  integer ( kind = 4 ) a(n)
  integer ( kind = 4 ) i
  character ( len = * ) title

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) trim ( title )
  write ( *, '(a)' ) ' '
  do i = 1, n
    write ( *, '(i6,i10)' ) i, a(i)
  end do

  return
end
subroutine timestamp ( )

!*****************************************************************************80
!
!! TIMESTAMP prints the current YMDHMS date as a time stamp.
!
!  Example:
!
!    31 May 2001   9:45:54.872 AM
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    18 May 2013
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    None
!
  implicit none

  character ( len = 8 ) ampm
  integer ( kind = 4 ) d
  integer ( kind = 4 ) h
  integer ( kind = 4 ) m
  integer ( kind = 4 ) mm
  character ( len = 9 ), parameter, dimension(12) :: month = (/ &
    'January  ', 'February ', 'March    ', 'April    ', &
    'May      ', 'June     ', 'July     ', 'August   ', &
    'September', 'October  ', 'November ', 'December ' /)
  integer ( kind = 4 ) n
  integer ( kind = 4 ) s
  integer ( kind = 4 ) values(8)
  integer ( kind = 4 ) y

  call date_and_time ( values = values )

  y = values(1)
  m = values(2)
  d = values(3)
  h = values(5)
  n = values(6)
  s = values(7)
  mm = values(8)

  if ( h < 12 ) then
    ampm = 'AM'
  else if ( h == 12 ) then
    if ( n == 0 .and. s == 0 ) then
      ampm = 'Noon'
    else
      ampm = 'PM'
    end if
  else
    h = h - 12
    if ( h < 12 ) then
      ampm = 'PM'
    else if ( h == 12 ) then
      if ( n == 0 .and. s == 0 ) then
        ampm = 'Midnight'
      else
        ampm = 'AM'
      end if
    end if
  end if

  write ( *, '(i2,1x,a,1x,i4,2x,i2,a1,i2.2,a1,i2.2,a1,i3.3,1x,a)' ) &
    d, trim ( month(m) ), y, h, ':', n, ':', s, '.', mm, trim ( ampm )

  return
end

MODULE Types

!      ALGORITHM 643, COLLECTED ALGORITHMS FROM ACM.
!      THIS WORK PUBLISHED IN TRANSACTIONS ON MATHEMATICAL SOFTWARE,
!      VOL. 19, NO. 4, DECEMBER, 1993, PP. 484-488.

! This version by amiller @ bigpond.net.au
! http://users.bigpond.net.au/amiller

! Latest revision - 1 March 2003

IMPLICIT NONE

INTEGER, PARAMETER, PUBLIC :: dp = SELECTED_REAL_KIND(14, 60)

END MODULE


MODULE Fisher_Exact

USE Types

CONTAINS


!-----------------------------------------------------------------------
!  Name:       FEXACT

!  Purpose:    Computes Fisher's exact test probabilities and a hybrid
!              approximation to Fisher exact test probabilities for a
!              contingency table using the network algorithm.

!  Usage:      CALL FEXACT (NROW, NCOL, TABLE, LDTABL, EXPECT, PERCNT,
!                          EMIN, WKSPACE, PRT, PRE)

!  Arguments:
!     NROW   - The number of rows in the table.  (Input)
!     NCOL   - The number of columns in the table.  (Input)
!     TABLE  - NROW by NCOL matrix containing the contingency table. (Input)
!     LDTABL - Leading dimension of TABLE exactly as specified in the
!              dimension statement in the calling program.  (Input)
!     EXPECT - Expected value used in the hybrid algorithm for
!              deciding when to use asymptotic theory probabilities. (Input)
!              If EXPECT <= 0.0 then asymptotic theory probabilities
!              are not used and Fisher exact test probabilities are
!              computed.  Otherwise, if PERCNT or more of the cells in
!              the remaining table have estimated expected values of
!              EXPECT or more, with no remaining cell having expected
!              value less than EMIN, then asymptotic chi-squared
!              probabilities are used.  See the algorithm section of the
!              manual document for details.  Use EXPECT = 5.0 to obtain
!              the 'Cochran' condition.
!     PERCNT - Percentage of remaining cells that must have estimated
!              expected  values greater than EXPECT before asymptotic
!              probabilities can be used.  (Input)
!              See argument EXPECT for details.  Use PERCNT = 80.0 to
!              obtain the 'Cochran' condition.
!     EMIN   - Minimum cell estimated expected value allowed for
!              asymptotic chi-squared probabilities to be used.  (Input)
!              See argument EXPECT for details.  Use EMIN = 1.0 to
!              obtain the 'Cochran' condition.
!     WKSPACE - Workspace size (Input)
!     PRT    - Probability of the observed table for fixed marginal
!              totals.  (Output)
!     PRE    - Table p-value.  (Output)
!              PRE is the probability of a more extreme table, where
!              'extreme' is in a probabilistic sense.
!              If EXPECT < 0 then the Fisher exact probability is returned.
!              Otherwise, an approximation to the Fisher exact probability is
!              computed based upon asymptotic chi-squared probabilities for
!              ``large'' table expected values.  The user defines ``large''
!              through the arguments EXPECT, PERCNT, and EMIN.

!  Remarks:
!  1. For many problems one megabyte or more of workspace can be required.
!     If the environment supports it, the user should begin by increasing
!     the workspace used to 200,000 units.

!  2. In FEXACT, LDSTP = 30*LDKEY.  The proportion of table space used by STP
!     may be changed by changing the line MULT = 30 below to another value.

!  3. FEXACT may be converted to single precision by setting IREAL = 3,
!     and converting all REAL (dp) specifications (except the
!     specifications for RWRK, IWRK, and DWRK) to REAL.  This will
!     require changing the names and specifications of the intrinsic
!     functions ALOG, AMAX1, AMIN1, EXP, and REAL.  In addition, the
!     machine specific constants will need to be changed, and the name
!     DWRK will need to be changed to RWRK in the call to F2XACT.

!  4. Machine specific constants are specified and documented in F2XACT.
!     A missing value code is specified in both FEXACT and F2XACT.

!  5. Although not a restriction, is is not generally practical to call
!     this routine with large tables which are not sparse and in which the
!     'hybrid' algorithm has little effect.  For example, although it is
!     feasible to compute exact probabilities for the table
!            1 8 5 4 4 2 2
!            5 3 3 4 3 1 0
!           10 1 4 0 0 0 0,
!     computing exact probabilities for a similar table which has been
!     enlarged by the addition of an extra row (or column) may not be feasible.
!-----------------------------------------------------------------------

SUBROUTINE fexact (nrow, ncol, table, ldtabl, expect, percnt, emin, wkspace, prt, pre)

!                                  SPECIFICATIONS FOR ARGUMENTS

INTEGER, INTENT(IN)     :: nrow
INTEGER, INTENT(IN)     :: ncol
REAL (dp), INTENT(IN)   :: table(:,:)
INTEGER, INTENT(IN)     :: ldtabl
REAL (dp), INTENT(IN)   :: expect
REAL (dp), INTENT(IN)   :: percnt
REAL (dp), INTENT(IN)   :: emin
INTEGER, OPTIONAL, INTENT(IN)     :: wkspace
REAL (dp), INTENT(OUT)  :: prt
REAL (dp), INTENT(OUT)  :: pre

!                                  SPECIFICATIONS FOR LOCAL VARIABLES
INTEGER   :: i, j, ldkey, ldstp, mult, nco, nro, ntot
REAL (dp) :: amiss
!                                  SPECIFICATIONS FOR INTRINSICS
! INTRINSIC  MAX0
! INTEGER :: MAX0
!                                  SPECIFICATIONS FOR SUBROUTINES
! EXTERNAL   prterr, f2xact
!                                  SPECIFICATIONS FOR FUNCTIONS
! EXTERNAL   iwork
! INTEGER :: iwork
!***********************************************************************
!                                  To increase the length of the table
!                                  of paste path lengths relative to the
!                                  length of the hash table, increase MULT
!***********************************************************************
mult   = 30
IF(PRESENT(wkspace)) THEN
  mult = wkspace
END IF
!***********************************************************************
!                                  AMISS is a missing value indicator which
!                                  is returned when the probability is not
!                                  defined.
!***********************************************************************
amiss = -12345.0D0

IF (nrow > ldtabl) THEN
  CALL prterr (1, 'NROW must be less than or equal to LDTABL.')
END IF
ntot = 0
DO i=1, nrow
  DO j=1, ncol
    IF (table(i,j) < 0) THEN
      CALL prterr (2, 'All elements of TABLE must be positive.')
    END IF
    ntot = ntot + table(i,j)
  END DO
END DO
IF (ntot == 0) THEN
  CALL prterr (3, 'All elements of TABLE are zero. '//  &
               'PRT and PRE are set to missing values (NaN, not a number).')
  prt = amiss
  pre = amiss
  GO TO 9000
END IF

nco = MAX(nrow,ncol)
nro = nrow + ncol - nco
ldkey = 500
ldstp = mult * ldkey

CALL f2xact (nrow, ncol, table, ldtabl, expect, percnt, emin,  &
             prt, pre, ldkey, ldstp, ntot, nco, nro)

9000 RETURN
END SUBROUTINE fexact


!-----------------------------------------------------------------------
!  Name:       F2XACT

!  Purpose:    Computes Fisher's exact test for a contingency table,
!              routine with workspace variables specified.

!  Usage:      CALL F2XACT (NROW, NCOL, TABLE, LDTABL, EXPECT, PERCNT, EMIN,
!                           PRT, PRE, LDKEY, LDSTP, NTOT, NCO, NRO)

!  N.B. Arguments FACT, ICO, IRO, KYY, IDIF, IRN, KEY, IPOIN, STP, IFRQ, DLP,
!       DSP, TM, KEY2, IWK & RWK have been removed, while arguments
!       LDKEY, LDSTP, NTOT, NCO & NRO have been added.
!-----------------------------------------------------------------------

SUBROUTINE f2xact (nrow, ncol, table, ldtabl, expect, percnt, emin, prt,  &
                   pre, ldkey, ldstp, ntotal, ncols, nrows)

!                                  SPECIFICATIONS FOR ARGUMENTS

INTEGER, INTENT(IN)     :: nrow
INTEGER, INTENT(IN)     :: ncol
REAL (dp), INTENT(IN)   :: table(:,:)
INTEGER, INTENT(IN)     :: ldtabl
REAL (dp), INTENT(IN)   :: expect
REAL (dp), INTENT(IN)   :: percnt
REAL (dp), INTENT(IN)   :: emin
REAL (dp), INTENT(OUT)  :: prt, pre
INTEGER, INTENT(IN)     :: ldkey, ldstp, ntotal, ncols, nrows

!                                  SPECIFICATIONS FOR LOCAL VARIABLES

INTEGER   :: ico(ncols), iro(ncols), kyy(ncols), idif(nrows), irn(nrows),  &
             key(2*ldkey), ipoin(2*ldkey), ifrq(6*ldstp), key2(2*ldkey)
REAL (dp) :: fact(0:ntotal), stp(2*ldstp), dlp(2*ldkey), dsp(2*ldkey),  &
             tm(2*ldkey)

INTEGER   :: i, iflag, ifreq, ii, ikkey, ikstp, ikstp2, ipn, ipo, itmp,  &
             itop, itp, j, jkey, jstp, jstp2, jstp3, jstp4, k, k1, kb, kd, &
             kmax, ks, kval, last, n, ncell, nco, nrb, nro, nro2, ntot
REAL (dp) :: dd, ddf, df, drn, dro, dspt, emn, obs, obs2, obs3, pastp, pv, tmp
LOGICAL   :: chisq, ipsh

!                                  SPECIFICATIONS FOR INTRINSICS
! INTRINSIC  DLOG, DMAX1, DMIN1, DEXP, MAX0, MIN0, MOD, NINT, DBLE
! INTEGER :: MAX, MIN0, MOD, nint
! REAL (dp) :: DLOG, DMAX1, DMIN1, DEXP, DBLE

!                                  SPECIFICATIONS FOR SUBROUTINES
! EXTERNAL   prterr, f3xact, f4xact, f5xact, f6xact, f7xact, isort

!                                  SPECIFICATIONS FOR FUNCTIONS
! EXTERNAL   f9xact, gammds
! REAL (dp) :: f9xact, gammds
!***********************************************************************
!                                  IMAX is the largest representable
!                                  integer on the machine
!***********************************************************************
! DATA imax/2147483647/
INTEGER, PARAMETER :: imax = HUGE(1)
!***********************************************************************
!                                  AMISS is a missing value indicator
!                                  which is returned when the
!                                  probability is not defined.
!***********************************************************************
REAL (dp), PARAMETER :: amiss = -12345.0_dp
!***********************************************************************
!                                  TOL is chosen as the square root of
!                                  the smallest relative spacing
!***********************************************************************
REAL (dp), PARAMETER :: tol = 3.45254e-07_dp
!***********************************************************************
!                                  EMX is a large positive value used
!                                  in comparing expected values
!***********************************************************************
REAL (dp), PARAMETER :: emx = 1.0e+30_dp
!                                  Initialize KEY array
DO i=1, 2*ldkey
  key(i)  = -9999
  key2(i) = -9999
END DO
!                                  Initialize parameters
pre  = 0.0
IF (expect > 0.0D0) THEN
  emn = emin
ELSE
  emn = emx
END IF
!                                  Check table dimensions
IF (nrow > ldtabl) THEN
  CALL prterr (1, 'NROW must be less than or equal to LDTABL.')
END IF
IF (ncol <= 1) THEN
  CALL prterr (4, 'NCOL must be greater than 1.0.')
END IF
!                                  Compute row marginals and total
ntot = 0
DO i=1, nrow
  iro(i) = 0
  DO j=1, ncol
    IF (table(i,j) < -0.0001D0) THEN
      CALL prterr (2, 'All elements of TABLE must be positive.')
    END IF
    iro(i) = iro(i) + nint(table(i,j))
    ntot   = ntot + nint(table(i,j))
  END DO
END DO

IF (ntot == 0) THEN
  CALL prterr (3, 'All elements of TABLE are zero. '//  &
               'PRT and PRE are set to missing values (NaN, not a number).')
  prt = amiss
  pre = amiss
  GO TO 9000
END IF
!                                  Column marginals
DO i=1, ncol
  ico(i) = 0
  DO j=1, nrow
    ico(i) = ico(i) + nint(table(j,i))
  END DO
END DO
!                                  sort
CALL isort (nrow, iro)
CALL isort (ncol, ico)
!                                  Determine row and column marginals

IF (nrow > ncol) THEN
  nro = ncol
  nco = nrow
!                                  Interchange row and column marginals
  DO i=1, nrow
    itmp = iro(i)
    IF (i <= ncol) iro(i) = ico(i)
    ico(i) = itmp
  END DO
ELSE
  nro = nrow
  nco = ncol
END IF

!                                  Get multiplers for stack
kyy(1) = 1
DO i=2, nro
!                                  Hash table multipliers
  IF (iro(i-1)+1 <= imax/kyy(i-1)) THEN
    kyy(i) = kyy(i-1)*(iro(i-1)+1)
    j      = j/kyy(i-1)
  ELSE
    CALL prterr (5, 'The hash table key cannot be computed because the'//   &
                 ' largest key is larger than the largest representable'//  &
                 ' integer.  The algorithm cannot proceed.')
  END IF
END DO
!                                  Maximum product
IF (iro(nro-1)+1 <= imax/kyy(nro-1)) THEN
  kmax = (iro(nro)+1)*kyy(nro-1)
ELSE
  CALL prterr (5, 'The hash table key cannot be computed because the'//   &
               ' largest key is larger than the largest representable'//  &
               ' integer.  The algorithm cannot proceed.')
  GO TO 9000
END IF
!                                  Compute log factorials
fact(0) = 0.0D0
fact(1) = 0.0D0
fact(2) = LOG(2.0D0)
DO i=3, ntot, 2
  fact(i) = fact(i-1) + LOG(DBLE(i))
  j       = i + 1
  IF (j <= ntot) fact(j) = fact(i) + fact(2) + fact(j/2) - fact(j/2-1)
END DO
!                                  Compute observed path length: OBS
obs  = tol
ntot = 0
DO j=1, nco
  dd = 0.0
  DO i=1, nro
    IF (nrow <= ncol) THEN
      dd   = dd + fact(nint(table(i,j)))
      ntot = ntot + nint(table(i,j))
    ELSE
      dd   = dd + fact(nint(table(j,i)))
      ntot = ntot + nint(table(j,i))
    END IF
  END DO
  obs = obs + fact(ico(j)) - dd
END DO
!                                  Denominator of observed table: DRO
dro = f9xact(nro, ntot, iro, fact)
prt = EXP(obs-dro)
!                                  Initialize pointers
k        = nco
last     = ldkey + 1
jkey     = ldkey + 1
jstp     = ldstp + 1
jstp2    = 3*ldstp + 1
jstp3    = 4*ldstp + 1
jstp4    = 5*ldstp + 1
ikkey    = 0
ikstp    = 0
ikstp2   = 2*ldstp
ipo      = 1
ipoin(1) = 1
stp(1)   = 0.0
ifrq(1)  = 1
ifrq(ikstp2+1) = -1

110 kb = nco - k + 1
ks   = 0
n    = ico(kb)
kd   = nro + 1
kmax = nro
!                                  IDIF is the difference in going to the
!                                  daughter
idif(1:nro) = 0
!                                  Generate the first daughter
130 kd = kd - 1
ntot     = MIN(n, iro(kd))
idif(kd) = ntot
IF (idif(kmax) == 0) kmax = kmax - 1
n = n - ntot
IF (n > 0 .AND. kd /= 1) GO TO 130
IF (n /= 0) GO TO 310

k1   = k - 1
n    = ico(kb)
ntot = 0
DO i=kb + 1, nco
  ntot = ntot + ico(i)
END DO
!                                  Arc to daughter length = ICO(KB)
150 DO i=1, nro
  irn(i) = iro(i) - idif(i)
END DO
!                                  Sort irn
IF (k1 > 1) THEN
  IF (nro == 2) THEN
    IF (irn(1) > irn(2)) THEN
      ii     = irn(1)
      irn(1) = irn(2)
      irn(2) = ii
    END IF
  ELSE IF (nro == 3) THEN
    ii = irn(1)
    IF (ii > irn(3)) THEN
      IF (ii > irn(2)) THEN
        IF (irn(2) > irn(3)) THEN
          irn(1) = irn(3)
          irn(3) = ii
        ELSE
          irn(1) = irn(2)
          irn(2) = irn(3)
          irn(3) = ii
        END IF
      ELSE
        irn(1) = irn(3)
        irn(3) = irn(2)
        irn(2) = ii
      END IF
    ELSE IF (ii > irn(2)) THEN
      irn(1) = irn(2)
      irn(2) = ii
    ELSE IF (irn(2) > irn(3)) THEN
      ii     = irn(2)
      irn(2) = irn(3)
      irn(3) = ii
    END IF
  ELSE
    DO j=2, nro
      i  = j - 1
      ii = irn(j)
      170 IF (ii < irn(i)) THEN
        irn(i+1) = irn(i)
        i        = i - 1
        IF (i > 0) GO TO 170
      END IF
      irn(i+1) = ii
    END DO
  END IF
!                                  Adjust start for zero
  DO i=1, nro
    IF (irn(i) /= 0) EXIT
  END DO
  nrb = i
  nro2 = nro - i + 1
ELSE
  nrb  = 1
  nro2 = nro
END IF
!                                  Some table values
ddf = f9xact(nro, n, idif, fact)
drn = f9xact(nro2, ntot, irn(nrb:), fact) - dro + ddf
!                                  Get hash value
IF (k1 > 1) THEN
  kval = irn(1) + irn(2)*kyy(2)
  DO i=3, nro
    kval = kval + irn(i)*kyy(i)
  END DO
!                                  Get hash table entry
  i = MOD(kval, 2*ldkey) + 1
!                                  Search for unused location
  DO itp=i, 2*ldkey
    ii = key2(itp)
    IF (ii == kval) THEN
      GO TO 240
    ELSE IF (ii < 0) THEN
      key2(itp) = kval
      dlp(itp)  = 1.0D0
      dsp(itp)  = 1.0D0
      GO TO 240
    END IF
  END DO

  DO itp=1, i - 1
    ii = key2(itp)
    IF (ii == kval) THEN
      GO TO 240
    ELSE IF (ii < 0) THEN
      key2(itp) = kval
      dlp(itp)  = 1.0
      GO TO 240
    END IF
  END DO

  CALL prterr (6, 'LDKEY is too small.  It is not possible to '//  &
               'give thevalue of LDKEY required, but you could '//  &
               'try doubling LDKEY (and possibly LDSTP).')
END IF

240 ipsh = .true.
!                                  Recover pastp
ipn   = ipoin(ipo+ikkey)
pastp = stp(ipn+ikstp)
ifreq = ifrq(ipn+ikstp)
!                                  Compute shortest and longest path
IF (k1 > 1) THEN
  obs2 = obs - fact(ico(kb+1)) - fact(ico(kb+2)) - ddf
  DO i=3, k1
    obs2 = obs2 - fact(ico(kb+i))
  END DO

  IF (dlp(itp) > 0.0D0) THEN
    dspt = obs - obs2 - ddf
!                                  Compute longest path
    dlp(itp) = 0.0D0
    CALL f3xact (nro2, irn(nrb:), k1, ico(kb+1:), dlp(itp), ntot, fact, tol)
    dlp(itp) = MIN(0.0D0,dlp(itp))
!                                  Compute shortest path
    dsp(itp) = dspt
    CALL f4xact (nro2, irn(nrb:), k1, ico(kb+1:), dsp(itp), fact, tol)
    dsp(itp) = MIN(0.0_dp, dsp(itp)-dspt)
!                                  Use chi-squared approximation?
    IF (DBLE(irn(nrb)*ico(kb+1))/DBLE(ntot) > emn) THEN
      ncell = 0.0
      DO i=1, nro2
        DO j=1, k1
          IF (irn(nrb+i-1)*ico(kb+j) >= ntot*expect) THEN
            ncell = ncell + 1
          END IF
        END DO
      END DO
      IF (ncell*100 >= k1*nro2*percnt) THEN
        tmp = 0.0
        DO i=1, nro2
          tmp = tmp + fact(irn(nrb+i-1)) - fact(irn(nrb+i-1)-1)
        END DO
        tmp = tmp*(k1-1)
        DO j=1, k1
          tmp = tmp + (nro2-1)*(fact(ico(kb+j)) - fact(ico(kb+j)-1))
        END DO
        df      = (nro2-1)*(k1-1)
        tmp     = tmp + df*1.83787706640934548356065947281D0
        tmp     = tmp - (nro2*k1-1)*(fact(ntot) - fact(ntot-1))
        tm(itp) = -2.0D0*(obs-dro) - tmp
      ELSE
!                                  tm(itp) set to a flag value
        tm(itp) = -9876.0D0
      END IF
    ELSE
      tm(itp) = -9876.0D0
    END IF
  END IF
  obs3 = obs2 - dlp(itp)
  obs2 = obs2 - dsp(itp)
  IF (tm(itp) == -9876.0D0) THEN
    chisq = .false.
  ELSE
    chisq = .true.
    tmp   = tm(itp)
  END IF
ELSE
  obs2 = obs - drn - dro
  obs3 = obs2
END IF
!                                  Process node with new PASTP
300 IF (pastp <= obs3) THEN
!                                  Update pre
  pre = pre + DBLE(ifreq)*EXP(pastp+drn)

ELSE IF (pastp < obs2) THEN
  IF (chisq) THEN
    df  = (nro2-1)*(k1-1)
    pv  = 1.0 - gammad( MAX(0.0D0, tmp+2.0D0*(pastp+drn))/2.0D0, df/2.0D0)
    pre = pre + DBLE(ifreq)*EXP(pastp+drn)*pv
  ELSE
!                                  Put daughter on queue
    CALL f5xact (pastp+ddf, tol, kval, key(jkey:), ldkey, ipoin(jkey:),  &
                 stp(jstp:), ldstp, ifrq(jstp:), ifrq(jstp2:),   &
                 ifrq(jstp3:), ifrq(jstp4:), ifreq, itop, ipsh)
    ipsh = .false.
  END IF
END IF
!                                  Get next PASTP on chain
ipn = ifrq(ipn+ikstp2)
IF (ipn > 0) THEN
  pastp = stp(ipn+ikstp)
  ifreq = ifrq(ipn+ikstp)
  GO TO 300
END IF
!                                  Generate a new daughter node
CALL f7xact (kmax, iro, idif, kd, ks, iflag)
IF (iflag /= 1) GO TO 150
!                                  Go get a new mother from stage K
310 iflag = 1
CALL f6xact (nro, iro, iflag, kyy, key(ikkey+1:), ldkey, last, ipo)
!                                  Update pointers
IF (iflag == 3) THEN
  k      = k - 1
  itop   = 0
  ikkey  = jkey - 1
  ikstp  = jstp - 1
  ikstp2 = jstp2 - 1
  jkey   = ldkey - jkey + 2
  jstp   = ldstp - jstp + 2
  jstp2  = 2*ldstp + jstp
  DO i=1, 2*ldkey
    key2(i) = -9999
  END DO
  IF (k >= 2) GO TO 310
ELSE
  GO TO 110
END IF

9000 RETURN
END SUBROUTINE f2xact


!-----------------------------------------------------------------------
!  Name:       F3XACT

!  Purpose:    Computes the shortest path length for a given table.

!  Usage:      CALL F3XACT (NROW, IROW, NCOL, ICOL, DLP, MM, FACT, TOL)

!  Arguments:
!     NROW   - The number of rows in the table.  (Input)
!     IROW   - Vector of length NROW containing the row sums for the
!              table.  (Input)
!     NCOL   - The number of columns in the table.  (Input)
!     ICOL   - Vector of length K containing the column sums for the
!              table.  (Input)
!     DLP    - The longest path for the table.  (Output)
!     MM     - The total count in the table.  (Output)
!     FACT   - Vector containing the logarithms of factorials.  (Input)
!     ICO    - Work vector of length MAX(NROW,NCOL).
!     IRO    - Work vector of length MAX(NROW,NCOL).
!     IT     - Work vector of length MAX(NROW,NCOL).
!     LB     - Work vector of length MAX(NROW,NCOL).
!     NR     - Work vector of length MAX(NROW,NCOL).
!     NT     - Work vector of length MAX(NROW,NCOL).
!     NU     - Work vector of length MAX(NROW,NCOL).
!     ITC    - Work vector of length 400.
!     IST    - Work vector of length 400.
!     STV    - Work vector of length 400.
!     ALEN   - Work vector of length MAX(NROW,NCOL).
!     TOL    - Tolerance.  (Input)

!  N.B. Arguments ICO, IRO, IT, LB, NR, NT, NU, ITC, IST, STV & ALEN
!       have been removed.
!-----------------------------------------------------------------------

SUBROUTINE f3xact (nrow, irow, ncol, icol, dlp, mm, fact, tol)

!                                  SPECIFICATIONS FOR ARGUMENTS

INTEGER, INTENT(IN)     :: nrow
INTEGER, INTENT(IN)     :: irow(:)
INTEGER, INTENT(IN)     :: ncol
INTEGER, INTENT(IN)     :: icol(:)
REAL (dp), INTENT(OUT)  :: dlp
INTEGER, INTENT(IN)     :: mm
REAL (dp), INTENT(IN)   :: fact(0:)
REAL (dp), INTENT(IN)   :: tol

!                                  SPECIFICATIONS FOR LOCAL VARIABLES

INTEGER, ALLOCATABLE   :: ico(:), iro(:), it(:), lb(:), nr(:), nt(:), nu(:)
REAL (dp), ALLOCATABLE :: alen(:)

INTEGER   :: i, ic1, ic2, ii, ipn, irl, ist(400), itc(400), itp, k, key, ks, &
             kyy, lev, n11, n12, nc1, nc1s, nco, nct, nn, nn1, nr1, nro, nrt
REAL (dp) :: stv(400), v, val, vmn
LOGICAL   :: xmin

!                                  SPECIFICATIONS FOR SAVE VARIABLES
INTEGER, SAVE :: ldst = 200, nitc = 0, nst = 0

!                                  SPECIFICATIONS FOR INTRINSICS
! INTRINSIC  DMIN1, INT, MOD, DBLE
! INTEGER :: INT, MOD
! REAL (dp) :: DMIN1, DBLE

!                                  SPECIFICATIONS FOR SUBROUTINES
! EXTERNAL   prterr, f10act, isort

nn = MAX(nrow, ncol)
ALLOCATE( ico(nn), iro(nn), it(nn), lb(nn), nr(nn), nt(nn), nu(nn),   &
          alen(0:nn) )

alen(0:ncol) = 0.0_dp
ist(1:400) = -1
!                                  nrow is 1
IF (nrow <= 1) THEN
  IF (nrow > 0) THEN
    dlp = dlp - fact(icol(1))
    DO i=2, ncol
      dlp = dlp - fact(icol(i))
    END DO
  END IF
  GO TO 9000
END IF
!                                  ncol is 1
IF (ncol <= 1) THEN
  IF (ncol > 0) THEN
    dlp = dlp - fact(irow(1)) - fact(irow(2))
    DO i=3, nrow
      dlp = dlp - fact(irow(i))
    END DO
  END IF
  GO TO 9000
END IF
!                                  2 by 2 table
IF (nrow*ncol == 4) THEN
  n11 = (irow(1)+1)*(icol(1)+1)/(mm+2)
  n12 = irow(1) - n11
  dlp = dlp - fact(n11) - fact(n12) - fact(icol(1)-n11) - fact(icol(2)-n12)
  GO TO 9000
END IF
!                                  Test for optimal table
val  = 0.0
xmin = .false.
IF (irow(nrow) <= irow(1)+ncol) THEN
  CALL f10act (nrow, irow, ncol, icol, val, xmin, fact, lb, nu, nr)
END IF
IF (.NOT.xmin) THEN
  IF (icol(ncol) <= icol(1)+nrow) THEN
    CALL f10act (ncol, icol, nrow, irow, val, xmin, fact, lb, nu, nr)
  END IF
END IF

IF (xmin) THEN
  dlp = dlp - val
  GO TO 9000
END IF
!                                  Setup for dynamic programming
nn = mm
!                                  Minimize ncol
IF (nrow >= ncol) THEN
  nro = nrow
  nco = ncol

  DO i=1, nrow
    iro(i) = irow(i)
  END DO

  ico(1) = icol(1)
  nt(1)  = nn - ico(1)
  DO i=2, ncol
    ico(i) = icol(i)
    nt(i)  = nt(i-1) - ico(i)
  END DO
ELSE
  nro = ncol
  nco = nrow

  ico(1) = irow(1)
  nt(1)  = nn - ico(1)
  DO i=2, nrow
    ico(i) = irow(i)
    nt(i)  = nt(i-1) - ico(i)
  END DO

  DO i=1, ncol
    iro(i) = icol(i)
  END DO
END IF
!                                  Initialize pointers
vmn  = 1.0D10
nc1s = nco - 1
irl  = 1
ks   = 0
k    = ldst
kyy  = ico(nco) + 1
GO TO 100
!                                  Test for optimality
90 xmin = .false.
IF (iro(nro) <= iro(irl)+nco) THEN
  CALL f10act (nro, iro(irl:), nco, ico, val, xmin, fact, lb, nu, nr)
END IF
IF (.NOT.xmin) THEN
  IF (ico(nco) <= ico(1)+nro) THEN
    CALL f10act (nco, ico, nro, iro(irl:), val, xmin, fact, lb, nu, nr)
  END IF
END IF

IF (xmin) THEN
  IF (val < vmn) vmn = val
  GO TO 200
END IF
!                                  Setup to generate new node
100 lev = 1
nr1   = nro - 1
nrt   = iro(irl)
nct   = ico(1)
lb(1) = INT(DBLE((nrt+1)*(nct+1))/DBLE(nn+nr1*nc1s+1)-tol) - 1
nu(1) = INT(DBLE((nrt+nc1s)*(nct+nr1))/DBLE(nn+nr1+nc1s)) - lb(1) + 1
nr(1) = nrt - lb(1)
!                                  Generate a node
110 nu(lev) = nu(lev) - 1
IF (nu(lev) == 0) THEN
  IF (lev == 1) GO TO 200
  lev = lev - 1
  GO TO 110
END IF
lb(lev) = lb(lev) + 1
nr(lev) = nr(lev) - 1
120 alen(lev) = alen(lev-1) + fact(lb(lev))
IF (lev < nc1s) THEN
  nn1     = nt(lev)
  nrt     = nr(lev)
  lev     = lev + 1
  nc1     = nco - lev
  nct     = ico(lev)
  lb(lev) = DBLE((nrt+1)*(nct+1))/DBLE(nn1+nr1*nc1+1) - tol
  nu(lev) = DBLE((nrt+nc1)*(nct+nr1))/DBLE(nn1+nr1+nc1) - lb(lev) + 1
  nr(lev) = nrt - lb(lev)
  GO TO 120
END IF
alen(nco) = alen(lev) + fact(nr(lev))
lb(nco)   = nr(lev)

v = val + alen(nco)
IF (nro == 2) THEN
!                                  Only 1 row left
  v = v + fact(ico(1)-lb(1)) + fact(ico(2)-lb(2))
  DO i=3, nco
    v = v + fact(ico(i)-lb(i))
  END DO
  IF (v < vmn) vmn = v
ELSE IF (nro == 3 .AND. nco == 2) THEN
!                                  3 rows and 2 columns
  nn1 = nn - iro(irl) + 2
  ic1 = ico(1) - lb(1)
  ic2 = ico(2) - lb(2)
  n11 = (iro(irl+1)+1)*(ic1+1)/nn1
  n12 = iro(irl+1) - n11
  v   = v + fact(n11) + fact(n12) + fact(ic1-n11) + fact(ic2-n12)
  IF (v < vmn) vmn = v
ELSE
!                                  Column marginals are new node
  DO i=1, nco
    it(i) = ico(i) - lb(i)
  END DO
!                                  Sort column marginals
  IF (nco == 2) THEN
    IF (it(1) > it(2)) THEN
      ii    = it(1)
      it(1) = it(2)
      it(2) = ii
    END IF
  ELSE IF (nco == 3) THEN
    ii = it(1)
    IF (ii > it(3)) THEN
      IF (ii > it(2)) THEN
        IF (it(2) > it(3)) THEN
          it(1) = it(3)
          it(3) = ii
        ELSE
          it(1) = it(2)
          it(2) = it(3)
          it(3) = ii
        END IF
      ELSE
        it(1) = it(3)
        it(3) = it(2)
        it(2) = ii
      END IF
    ELSE IF (ii > it(2)) THEN
      it(1) = it(2)
      it(2) = ii
    ELSE IF (it(2) > it(3)) THEN
      ii    = it(2)
      it(2) = it(3)
      it(3) = ii
    END IF
  ELSE
    CALL isort (nco, it)
  END IF
!                                  Compute hash value
  key = it(1)*kyy + it(2)
  DO i=3, nco
    key = it(i) + key*kyy
  END DO
!                                  Table index
  ipn = MOD(key,ldst) + 1
!                                  Find empty position
  ii = ks + ipn
  DO itp=ipn, ldst
    IF (ist(ii) < 0) THEN
      GO TO 180
    ELSE IF (ist(ii) == key) THEN
      GO TO 190
    END IF
    ii = ii + 1
  END DO

  ii = ks + 1
  DO itp=1, ipn - 1
    IF (ist(ii) < 0) THEN
      GO TO 180
    ELSE IF (ist(ii) == key) THEN
      GO TO 190
    END IF
    ii = ii + 1
  END DO

  CALL prterr (30, 'Stack length exceeded in f3xact.'//  &
               '  This problem should not occur.')
!                                  Push onto stack
  180 ist(ii) = key
  stv(ii) = v
  nst     = nst + 1
  ii      = nst + ks
  itc(ii) = itp
  GO TO 110
!                                  Marginals already on stack
  190 stv(ii) = MIN(v,stv(ii))
END IF
GO TO 110
!                                  Pop item from stack
200 IF (nitc > 0) THEN
!                                  Stack index
  itp      = itc(nitc+k) + k
  nitc     = nitc - 1
  val      = stv(itp)
  key      = ist(itp)
  ist(itp) = -1
!                                  Compute marginals
  DO i=nco, 2, -1
    ico(i) = MOD(key,kyy)
    key    = key/kyy
  END DO
  ico(1) = key
!                                  Set up nt array
  nt(1) = nn - ico(1)
  DO i=2, nco
    nt(i) = nt(i-1) - ico(i)
  END DO
  GO TO 90

ELSE IF (nro > 2 .AND. nst > 0) THEN
!                                  Go to next level
  nitc = nst
  nst  = 0
  k    = ks
  ks   = ldst - ks
  nn   = nn - iro(irl)
  irl  = irl + 1
  nro  = nro - 1
  GO TO 200
END IF

dlp = dlp - vmn

9000 DEALLOCATE( ico, iro, it, lb, nr, nt, nu, alen )
RETURN
END SUBROUTINE f3xact


!-----------------------------------------------------------------------
!  Name:       F4XACT

!  Purpose:    Computes the longest path length for a given table.

!  Usage:      CALL F4XACT (NROW, IROW, NCOL, ICOL, DSP, FACT, TOL)

!  Arguments:
!     NROW   - The number of rows in the table.  (Input)
!     IROW   - Vector of length NROW containing the row sums for the
!              table.  (Input)
!     NCOL   - The number of columns in the table.  (Input)
!     ICOL   - Vector of length K containing the column sums for the
!              table.  (Input)
!     DSP    - The shortest path for the table.  (Output)
!     FACT   - Vector containing the logarithms of factorials.  (Input)
!     ICSTK  - NCOL by NROW+NCOL+1 work array.
!     NCSTK  - Work vector of length NROW+NCOL+1.
!     LSTK   - Work vector of length NROW+NCOL+1.
!     MSTK   - Work vector of length NROW+NCOL+1.
!     NSTK   - Work vector of length NROW+NCOL+1.
!     NRSTK  - Work vector of length NROW+NCOL+1.
!     IRSTK  - NROW by MAX(NROW,NCOL) work array.
!     YSTK   - Work vector of length NROW+NCOL+1.
!     TOL    - Tolerance.  (Input)

!  N.B. Arguments ICSTK, NCSTK, LSTK, MSTK, NSTK, NRSTK, IRSTK & YSTK
!       hev been removed.
!-----------------------------------------------------------------------

SUBROUTINE f4xact (nrow, irow, ncol, icol, dsp, fact, tol)

!                                  SPECIFICATIONS FOR ARGUMENTS

INTEGER, INTENT(IN)        :: nrow
INTEGER, INTENT(IN)        :: irow(:)
INTEGER, INTENT(IN)        :: ncol
INTEGER, INTENT(IN)        :: icol(:)
REAL (dp), INTENT(IN OUT)  :: dsp
REAL (dp), INTENT(IN)      :: fact(0:)
REAL (dp), INTENT(IN)      :: tol

!                                  SPECIFICATIONS FOR LOCAL VARIABLES
INTEGER   :: icstk(ncol,nrow+ncol+1), ncstk(nrow+ncol+1), lstk(nrow+ncol+1), &
             mstk(nrow+ncol+1), nstk(nrow+ncol+1), nrstk(nrow+ncol+1),  &
             irstk(nrow,nrow+ncol+1)
REAL (dp) :: ystk(nrow+ncol+1)
INTEGER   :: i, ic1, ict, ir1, irt, istk, j, k, l, m, mn, n, nco, nro
REAL (dp) :: amx, y
!                                  SPECIFICATIONS FOR SUBROUTINES
! EXTERNAL   f11act, f8xact
!                                  Take care of the easy cases first
IF (nrow == 1) THEN
  DO i=1, ncol
    dsp = dsp - fact(icol(i))
  END DO
  GO TO 9000
END IF

IF (ncol == 1) THEN
  DO i=1, nrow
    dsp = dsp - fact(irow(i))
  END DO
  GO TO 9000
END IF

IF (nrow*ncol == 4) THEN
  IF (irow(2) <= icol(2)) THEN
    dsp = dsp - fact(irow(2)) - fact(icol(1)) - fact(icol(2)-irow(2))
  ELSE
    dsp = dsp - fact(icol(2)) - fact(irow(1)) - fact(irow(2)-icol(2))
  END IF
  GO TO 9000
END IF
!                                  initialization before loop
DO i=1, nrow
  irstk(i,1) = irow(nrow-i+1)
END DO

DO j=1, ncol
  icstk(j,1) = icol(ncol-j+1)
END DO

nro      = nrow
nco      = ncol
nrstk(1) = nro
ncstk(1) = nco
ystk(1)  = 0.0
y        = 0.0
istk     = 1
l        = 1
amx      = 0.0

50 ir1 = irstk(1,istk)
ic1 = icstk(1,istk)
IF (ir1 > ic1) THEN
  IF (nro >= nco) THEN
    m = nco - 1
    n = 2
  ELSE
    m = nro
    n = 1
  END IF
ELSE IF (ir1 < ic1) THEN
  IF (nro <= nco) THEN
    m = nro - 1
    n = 1
  ELSE
    m = nco
    n = 2
  END IF
ELSE
  IF (nro <= nco) THEN
    m = nro - 1
    n = 1
  ELSE
    m = nco - 1
    n = 2
  END IF
END IF

60 IF (n == 1) THEN
  i = l
  j = 1
ELSE
  i = 1
  j = l
END IF

irt = irstk(i,istk)
ict = icstk(j,istk)
mn  = irt
IF (mn > ict) mn = ict
y = y + fact(mn)
IF (irt == ict) THEN
  nro = nro - 1
  nco = nco - 1
  CALL f11act (irstk(:,istk), i, nro, irstk(:,istk+1))
  CALL f11act (icstk(:,istk), j, nco, icstk(:,istk+1))
ELSE IF (irt > ict) THEN
  nco = nco - 1
  CALL f11act (icstk(:,istk), j, nco, icstk(:,istk+1))
  CALL f8xact (irstk(:,istk), irt-ict, i, nro, irstk(:,istk+1))
ELSE
  nro = nro - 1
  CALL f11act (irstk(:,istk), i, nro, irstk(:,istk+1))
  CALL f8xact (icstk(:,istk), ict-irt, j, nco, icstk(:,istk+1))
END IF

IF (nro == 1) THEN
  DO k=1, nco
    y = y + fact(icstk(k,istk+1))
  END DO
  GO TO 90
END IF

IF (nco == 1) THEN
  DO k=1, nro
    y = y + fact(irstk(k,istk+1))
  END DO
  GO TO 90
END IF

lstk(istk)  = l
mstk(istk)  = m
nstk(istk)  = n
istk        = istk + 1
nrstk(istk) = nro
ncstk(istk) = nco
ystk(istk)  = y
l           = 1
GO TO 50

90 IF (y > amx) THEN
  amx = y
  IF (dsp-amx <= tol) THEN
    dsp = 0.0
    GO TO 9000
  END IF
END IF

100 istk = istk - 1
IF (istk == 0) THEN
  dsp = dsp - amx
  IF (dsp-amx <= tol) dsp = 0.0
  GO TO 9000
END IF
l = lstk(istk) + 1

110 IF (l > mstk(istk)) GO TO 100
n   = nstk(istk)
nro = nrstk(istk)
nco = ncstk(istk)
y   = ystk(istk)
IF (n == 1) THEN
  IF (irstk(l,istk) < irstk(l-1,istk)) GO TO 60
ELSE IF (n == 2) THEN
  IF (icstk(l,istk) < icstk(l-1,istk)) GO TO 60
END IF

l = l + 1
GO TO 110

9000 RETURN
END SUBROUTINE f4xact


!-----------------------------------------------------------------------
!  Name:       F5XACT

!  Purpose:    Put node on stack in network algorithm.

!  Usage:      CALL F5XACT (PASTP, TOL, KVAL, KEY, LDKEY, IPOIN, STP,
!                          LDSTP, IFRQ, NPOIN, NR, NL, IFREQ, ITOP,
!                          IPSH)

!  Arguments:
!     PASTP  - The past path length.  (Input)
!     TOL    - Tolerance for equivalence of past path lengths.  (Input)
!     KVAL   - Key value.  (Input)
!     KEY    - Vector of length LDKEY containing the key values. (Input/output)
!     LDKEY  - Length of vector KEY.  (Input)
!     IPOIN  - Vector of length LDKEY pointing to the linked list
!              of past path lengths.  (Input/output)
!     STP    - Vector of length LSDTP containing the linked lists
!              of past path lengths.  (Input/output)
!     LDSTP  - Length of vector STP.  (Input)
!     IFRQ   - Vector of length LDSTP containing the past path
!              frequencies.  (Input/output)
!     NPOIN  - Vector of length LDSTP containing the pointers to
!              the next past path length.  (Input/output)
!     NR     - Vector of length LDSTP containing the right object
!              pointers in the tree of past path lengths. (Input/output)
!     NL     - Vector of length LDSTP containing the left object
!              pointers in the tree of past path lengths. (Input/output)
!     IFREQ  - Frequency of the current path length.  (Input)
!     ITOP   - Pointer to the top of STP.  (Input)
!     IPSH   - Option parameter.  (Input)
!              If IPSH is true, the past path length is found in the table KEY.
!              Otherwise the location of the past path length is assumed
!              known and to have been found in a previous call.
!-----------------------------------------------------------------------

SUBROUTINE f5xact (pastp, tol, kval, key, ldkey, ipoin, stp,  &
                   ldstp, ifrq, npoin, nr, nl, ifreq, itop, ipsh)

!                                  SPECIFICATIONS FOR ARGUMENTS

REAL (dp), INTENT(IN)   :: pastp
REAL (dp), INTENT(IN)   :: tol
INTEGER, INTENT(IN)     :: kval
INTEGER, INTENT(OUT)    :: key(:)
INTEGER, INTENT(IN)     :: ldkey
INTEGER, INTENT(OUT)    :: ipoin(:)
REAL (dp), INTENT(OUT)  :: stp(:)
INTEGER, INTENT(IN)     :: ldstp
INTEGER, INTENT(OUT)    :: ifrq(:)
INTEGER, INTENT(OUT)    :: npoin(:)
INTEGER, INTENT(OUT)    :: nr(:)
INTEGER, INTENT(OUT)    :: nl(:)
INTEGER, INTENT(IN)     :: ifreq
INTEGER, INTENT(IN OUT) :: itop
LOGICAL, INTENT(IN)     :: ipsh

!                                  SPECIFICATIONS FOR LOCAL VARIABLES
INTEGER   :: ipn, ird, itmp
REAL (dp) :: test1, test2
!                                  SPECIFICATIONS FOR SAVE VARIABLES
INTEGER, SAVE :: itp
!                                  SPECIFICATIONS FOR INTRINSICS
! INTRINSIC  MOD
! INTEGER :: MOD
!                                  SPECIFICATIONS FOR SUBROUTINES
! EXTERNAL   prterr

IF (ipsh) THEN
!                                  Convert KVAL to integer in range
!                                  1, ..., LDKEY.
  ird = MOD(kval,ldkey) + 1
!                                  Search for an unused location
  DO itp=ird, ldkey
    IF (key(itp) == kval) GO TO 40
    IF (key(itp) < 0) GO TO 30
  END DO

  DO itp=1, ird - 1
    IF (key(itp) == kval) GO TO 40
    IF (key(itp) < 0) GO TO 30
  END DO
!                                  Return if KEY array is full
  CALL prterr(6, 'LDKEY is too small for this problem.  It is '//  &
              'not possible to estimate the value of LDKEY '//  &
              'required, but twice the current value may be sufficient.')
!                                  Update KEY
  30 key(itp) = kval
  itop       = itop + 1
  ipoin(itp) = itop
!                                  Return if STP array full
  IF (itop > ldstp) THEN
    CALL prterr(7, 'LDSTP is too small for this problem.  It is not '//  &
                'possible to estimate the value of LDSTP required,'//  &
                'but twice the current value may be sufficient.')
  END IF
!                                  Update STP, etc.
  npoin(itop) = -1
  nr(itop)    = -1
  nl(itop)    = -1
  stp(itop)   = pastp
  ifrq(itop)  = ifreq
  GO TO 9000
END IF
!                                  Find location, if any, of pastp
40 ipn = ipoin(itp)
test1 = pastp - tol
test2 = pastp + tol

50 IF (stp(ipn) < test1) THEN
  ipn = nl(ipn)
  IF (ipn > 0) GO TO 50
ELSE IF (stp(ipn) > test2) THEN
  ipn = nr(ipn)
  IF (ipn > 0) GO TO 50
ELSE
  ifrq(ipn) = ifrq(ipn) + ifreq
  GO TO 9000
END IF
!                                  Return if STP array full
itop = itop + 1
IF (itop > ldstp) THEN
  CALL prterr(7, 'LDSTP is too small for this problem.  It is '//  &
              'not possible to estimate the value of LDSTP '//  &
              'required, but twice the current value may be sufficient.')
  GO TO 9000
END IF
!                                  Find location to add value
ipn  = ipoin(itp)
itmp = ipn
60 IF (stp(ipn) < test1) THEN
  itmp = ipn
  ipn  = nl(ipn)
  IF (ipn > 0) THEN
    GO TO 60
  ELSE
    nl(itmp) = itop
  END IF
ELSE IF (stp(ipn) > test2) THEN
  itmp = ipn
  ipn  = nr(ipn)
  IF (ipn > 0) THEN
    GO TO 60
  ELSE
    nr(itmp) = itop
  END IF
END IF
!                                  Update STP, etc.
npoin(itop) = npoin(itmp)
npoin(itmp) = itop
stp(itop)   = pastp
ifrq(itop)  = ifreq
nl(itop)    = -1
nr(itop)    = -1

9000 RETURN
END SUBROUTINE f5xact


!-----------------------------------------------------------------------
!  Name:       F6XACT

!  Purpose:    Pop a node off the stack.

!  Usage:      CALL F6XACT (NROW, IROW, IFLAG, KYY, KEY, LDKEY, LAST, IPN)

!  Arguments:
!     NROW   - The number of rows in the table.  (Input)
!     IROW   - Vector of length nrow containing the row sums on output. (Output)
!     IFLAG  - Set to 3 if there are no additional nodes to process. (Output)
!     KYY    - Constant mutlipliers used in forming the hash table key. (Input)
!     KEY    - Vector of length LDKEY containing the hash table keys.
!              (Input/output)
!     LDKEY  - Length of vector KEY.  (Input)
!     LAST   - Index of the last key popped off the stack. (Input/output)
!     IPN    - Pointer to the linked list of past path lengths. (Output)
!-----------------------------------------------------------------------

SUBROUTINE f6xact (nrow, irow, iflag, kyy, key, ldkey, last, ipn)
!                                  SPECIFICATIONS FOR ARGUMENTS

INTEGER, INTENT(IN)       :: nrow
INTEGER, INTENT(OUT)      :: irow(:)
INTEGER, INTENT(OUT)      :: iflag
INTEGER, INTENT(IN)       :: kyy(:)
INTEGER, INTENT(IN OUT)   :: key(:)
INTEGER, INTENT(IN)       :: ldkey
INTEGER, INTENT(IN OUT)   :: last
INTEGER, INTENT(OUT)      :: ipn

!                                  SPECIFICATIONS FOR LOCAL VARIABLES
INTEGER :: j, kval
!                                  SPECIFICATIONS FOR SAVE VARIABLES

10 last = last + 1
IF (last <= ldkey) THEN
  IF (key(last) < 0) GO TO 10
!                                  Get KVAL from the stack
  kval      = key(last)
  key(last) = -9999
  DO j=nrow, 2, -1
    irow(j) = kval/kyy(j)
    kval    = kval - irow(j)*kyy(j)
  END DO
  irow(1) = kval
  ipn     = last
ELSE
  last  = 0
  iflag = 3
END IF
RETURN
END SUBROUTINE f6xact


!-----------------------------------------------------------------------
!  Name:       F7XACT

!  Purpose:    Generate the new nodes for given marinal totals.

!  Usage:      CALL F7XACT (NROW, IMAX, IDIF, K, KS, IFLAG)

!  Arguments:
!     NROW   - The number of rows in the table.  (Input)
!     IMAX   - The row marginal totals.  (Input)
!     IDIF   - The column counts for the new column.  (Input/output)
!     K      - Indicator for the row to decrement.  (Input/output)
!     KS     - Indicator for the row to increment.  (Input/output)
!     IFLAG  - Status indicator.  (Output)
!              If IFLAG is zero, a new table was generated.  For
!              IFLAG = 1, no additional tables could be generated.
!-----------------------------------------------------------------------

SUBROUTINE f7xact (nrow, imax, idif, k, ks, iflag)
!                                  SPECIFICATIONS FOR ARGUMENTS

INTEGER, INTENT(IN)     :: nrow
INTEGER, INTENT(IN)     :: imax(:)
INTEGER, INTENT(IN OUT) :: idif(:)
INTEGER, INTENT(IN OUT) :: k
INTEGER, INTENT(IN OUT) :: ks
INTEGER, INTENT(OUT)    :: iflag

!                                  SPECIFICATIONS FOR LOCAL VARIABLES
INTEGER :: i, k1, m, mm
!                                  SPECIFICATIONS FOR INTRINSICS
! INTRINSIC  MIN0
! INTEGER :: MIN0

iflag = 0
!                                  Find node which can be incremented, ks
IF (ks == 0) THEN
  10 ks = ks + 1
  IF (idif(ks) == imax(ks)) GO TO 10
END IF
!                                 Find node to decrement (>ks)
IF (idif(k) > 0 .AND. k > ks) THEN
  idif(k) = idif(k) - 1
  30 k = k - 1
  IF (imax(k) == 0) GO TO 30
  m = k
!                                 Find node to increment (>=ks)
  40 IF (idif(m) >= imax(m)) THEN
    m = m - 1
    GO TO 40
  END IF
  idif(m) = idif(m) + 1
!                                 Change ks
  IF (m == ks) THEN
    IF (idif(m) == imax(m)) ks = k
  END IF
ELSE
!                                 Check for finish
  50 DO k1=k + 1, nrow
    IF (idif(k1) > 0) GO TO 70
  END DO
  iflag = 1
  GO TO 9000
!                                 Reallocate counts
  70 mm = 1
  DO i=1, k
    mm      = mm + idif(i)
    idif(i) = 0
  END DO
  k = k1
  90 k = k - 1
  m       = MIN(mm,imax(k))
  idif(k) = m
  mm      = mm - m
  IF (mm > 0 .AND. k /= 1) GO TO 90
!                                 Check that all counts reallocated
  IF (mm > 0) THEN
    IF (k1 /= nrow) THEN
      k = k1
      GO TO 50
    END IF
    iflag = 1
    GO TO 9000
  END IF
!                                 Get ks
  idif(k1) = idif(k1) - 1
  ks       = 0
  100    ks = ks + 1
  IF (ks > k) GO TO 9000
  IF (idif(ks) >= imax(ks)) GO TO 100
END IF

9000 RETURN
END SUBROUTINE f7xact


!-----------------------------------------------------------------------
!  Name:       F8XACT

!  Purpose:    Routine for reducing a vector when there is a zero element.

!  Usage:      CALL F8XACT (IROW, IS, I1, IZERO, NEW)

!  Arguments:
!     IROW   - Vector containing the row counts.  (Input)
!     IS     - Indicator.  (Input)
!     I1     - Indicator.  (Input)
!     IZERO  - Position of the zero.  (Input)
!     NEW    - Vector of new row counts.  (Output)
!-----------------------------------------------------------------------

SUBROUTINE f8xact (irow, is, i1, izero, NEW)

!                                  SPECIFICATIONS FOR ARGUMENTS

INTEGER, INTENT(IN)   :: irow(:)
INTEGER, INTENT(IN)   :: is
INTEGER, INTENT(IN)   :: i1
INTEGER, INTENT(IN)   :: izero
INTEGER, INTENT(OUT)  :: NEW(:)

!                                  SPECIFICATIONS FOR LOCAL VARIABLES
INTEGER :: i

DO i=1, i1 - 1
  NEW(i) = irow(i)
END DO

DO i=i1, izero - 1
  IF (is >= irow(i+1)) GO TO 30
  NEW(i) = irow(i+1)
END DO

i = izero
30 NEW(i) = is
40 i = i + 1
IF (i > izero) RETURN
NEW(i) = irow(i)
GO TO 40
END SUBROUTINE f8xact


!-----------------------------------------------------------------------
!  Name:       F9XACT

!  Purpose:    Computes the log of a multinomial coefficient.

!  Usage:      F9XACT(N, MM, IR, FACT)

!  Arguments:
!     N      - Length of IR.  (Input)
!     MM     - Number for factorial in numerator.  (Input)
!     IR     - Vector of length N containing the numebers for the
!              denominator of the factorial.  (Input)
!     FACT   - Table of log factorials.  (Input)
!     F9XACT  - The log of the multinomal coefficient.  (Output)
!-----------------------------------------------------------------------

FUNCTION f9xact (n, mm, ir, fact) RESULT(fn_val)
!                                  SPECIFICATIONS FOR ARGUMENTS

INTEGER, INTENT(IN)    :: n
INTEGER, INTENT(IN)    :: mm
INTEGER, INTENT(IN)    :: ir(:)
REAL (dp), INTENT(IN)  :: fact(0:)
REAL (dp)              :: fn_val

!                                  SPECIFICATIONS FOR LOCAL VARIABLES
INTEGER :: k

fn_val = fact(mm)
DO k=1, n
  fn_val = fn_val - fact(ir(k))
END DO

RETURN
END FUNCTION f9xact


!-----------------------------------------------------------------------
!  Name:       F10ACT

!  Purpose:    Computes the shortest path length for special tables.

!  Usage:      CALL F10ACT (NROW, IROW, NCOL, ICOL, VAL, XMIN, FACT, ND,
!                          NE, M)

!  Arguments:
!     NROW   - The number of rows in the table.  (Input)
!     IROW   - Vector of length NROW containing the row totals.  (Input)
!     NCOL   - The number of columns in the table.  (Input)
!     ICO    - Vector of length NCOL containing the column totals. (Input)
!     VAL    - The shortest path.  (Output)
!     XMIN   - Set to true if shortest path obtained.  (Output)
!     FACT   - Vector containing the logarithms of factorials. (Input)
!     ND     - Workspace vector of length NROW.
!     NE     - Workspace vector of length NCOL.
!     M      - Workspace vector of length NCOL.

!  Chapter:    STAT/LIBRARY Categorical and Discrete Data Analysis
!-----------------------------------------------------------------------

SUBROUTINE f10act (nrow, irow, ncol, icol, val, xmin, fact, nd, NE, m)

!                                  SPECIFICATIONS FOR ARGUMENTS

INTEGER, INTENT(IN)     :: nrow
INTEGER, INTENT(IN)     :: irow(:)
INTEGER, INTENT(IN)     :: ncol
INTEGER, INTENT(IN)     :: icol(:)
REAL (dp), INTENT(OUT)  :: val
LOGICAL, INTENT(OUT)    :: xmin
REAL (dp), INTENT(IN)   :: fact(0:)
INTEGER, INTENT(OUT)    :: nd(:)
INTEGER, INTENT(OUT)    :: NE(:)
INTEGER, INTENT(OUT)    :: m(:)

!                                  SPECIFICATIONS FOR LOCAL VARIABLES
INTEGER :: i, is, ix, nrw1

DO i=1, nrow - 1
  nd(i) = 0
END DO

is    = icol(1)/nrow
NE(1) = is
ix    = icol(1) - nrow*is
m(1)  = ix
IF (ix /= 0) nd(ix) = nd(ix) + 1

DO i=2, ncol
  ix    = icol(i)/nrow
  NE(i) = ix
  is    = is + ix
  ix    = icol(i) - nrow*ix
  m(i)  = ix
  IF (ix /= 0) nd(ix) = nd(ix) + 1
END DO

DO i=nrow - 2, 1, -1
  nd(i) = nd(i) + nd(i+1)
END DO

ix   = 0
nrw1 = nrow + 1
DO i=nrow, 2, -1
  ix = ix + is + nd(nrw1-i) - irow(i)
  IF (ix < 0) RETURN
END DO

DO i=1, ncol
  ix  = NE(i)
  is  = m(i)
  val = val + is*fact(ix+1) + (nrow-is)*fact(ix)
END DO
xmin = .true.

RETURN
END SUBROUTINE f10act


!-----------------------------------------------------------------------
!  Name:       F11ACT

!  Purpose:    Routine for revising row totals.

!  Usage:      CALL F11ACT (IROW, I1, I2, NEW)

!  Arguments:
!     IROW   - Vector containing the row totals.  (Input)
!     I1     - Indicator.  (Input)
!     I2     - Indicator.  (Input)
!     NEW    - Vector containing the row totals.  (Input) ??
!-----------------------------------------------------------------------

SUBROUTINE f11act (irow, i1, i2, NEW)
!                                  SPECIFICATIONS FOR ARGUMENTS

INTEGER, INTENT(IN)   :: irow(:)
INTEGER, INTENT(IN)   :: i1
INTEGER, INTENT(IN)   :: i2
INTEGER, INTENT(OUT)  :: NEW(:)

!                                  SPECIFICATIONS FOR LOCAL VARIABLES
INTEGER :: i

DO i=1, i1 - 1
  NEW(i) = irow(i)
END DO

DO i=i1, i2
  NEW(i) = irow(i+1)
END DO

RETURN
END SUBROUTINE f11act


!-----------------------------------------------------------------------
!  Name:       ISORT

!  Purpose:    Shell sort for an integer vector.

!  Usage:      CALL ISORT (N, IX)

!  Arguments:
!     N      - Lenth of vector IX.  (Input)
!     IX     - Vector to be sorted.  (Input/output)
!-----------------------------------------------------------------------

SUBROUTINE isort (n, ix)
!                                  SPECIFICATIONS FOR ARGUMENTS

INTEGER, INTENT(IN)      :: n
INTEGER, INTENT(IN OUT)  :: ix(:)

!                                  SPECIFICATIONS FOR LOCAL VARIABLES
INTEGER :: i, ikey, il(10), it, iu(10), j, kl, ku, m

!                                  SPECIFICATIONS FOR SUBROUTINES
! EXTERNAL   prterr
!                                  Sort IX
m = 1
i = 1
j = n
10 IF (i >= j) GO TO 40
kl   = i
ku   = j
ikey = i
j    = j + 1
!                                  Find element in first half
20 i = i + 1
IF (i < j) THEN
  IF (ix(ikey) > ix(i)) GO TO 20
END IF
!                                  Find element in second half
30 j = j - 1
IF (ix(j) > ix(ikey)) GO TO 30
!                                  Interchange
IF (i < j) THEN
  it    = ix(i)
  ix(i) = ix(j)
  ix(j) = it
  GO TO 20
END IF
it       = ix(ikey)
ix(ikey) = ix(j)
ix(j)    = it
!                                  Save upper and lower subscripts of
!                                  the array yet to be sorted
IF (m < 11) THEN
  IF (j-kl < ku-j) THEN
    il(m) = j + 1
    iu(m) = ku
    i     = kl
    j     = j - 1
  ELSE
    il(m) = kl
    iu(m) = j - 1
    i     = j + 1
    j     = ku
  END IF
  m = m + 1
  GO TO 10
ELSE
  CALL prterr (20, 'This should never occur.')
END IF
!                                  Use another segment
40 m = m - 1
IF (m == 0) GO TO 9000
i = il(m)
j = iu(m)
GO TO 10

9000 RETURN
END SUBROUTINE isort


FUNCTION gammad(x, p) RESULT(fn_val)

!      ALGORITHM AS239  APPL. STATIST. (1988) VOL. 37, NO. 3

!      Computation of the Incomplete Gamma Integral

!      Auxiliary functions required: LNGAMMA = logarithm of the gamma
!      function, and ALNORM = algorithm AS66

! ELF90-compatible version by Alan Miller
! Latest revision - 29 November 1997

! N.B. Argument IFAULT has been removed

REAL (dp), INTENT(IN) :: x, p
REAL (dp)             :: fn_val

! Local variables
REAL (dp)             :: pn1, pn2, pn3, pn4, pn5, pn6, arg, c, rn, a, b, an
REAL (dp), PARAMETER  :: zero = 0._dp, one = 1._dp, two = 2._dp, &
                         oflo = 1.d+37, three = 3._dp, nine = 9._dp, &
                         tol = 1.d-14, xbig = 1.d+8, plimit = 1000._dp, &
                         elimit = -88._dp

fn_val = zero

!      Check that we have valid values for X and P

IF (p <= zero .OR. x < zero) THEN
  WRITE(*, *) 'AS239: Either p <= 0 or x < 0'
  RETURN
END IF
IF (x == zero) RETURN

!      Use a normal approximation if P > PLIMIT

IF (p > plimit) THEN
  pn1 = three * SQRT(p) * ((x / p) ** (one / three) + one /(nine * p) - one)
  fn_val = alnorm(pn1, .false.)
  RETURN
END IF

!      If X is extremely large compared to P then set fn_val = 1

IF (x > xbig) THEN
  fn_val = one
  RETURN
END IF

IF (x <= one .OR. x < p) THEN

!      Use Pearson's series expansion.
!      (Note that P is not large enough to force overflow in lngamma).
!      No need to test IFAULT on exit since P > 0.

  arg = p * LOG(x) - x - lngamma(p + one)
  c = one
  fn_val = one
  a = p
  40   a = a + one
  c = c * x / a
  fn_val = fn_val + c
  IF (c > tol) GO TO 40
  arg = arg + LOG(fn_val)
  fn_val = zero
  IF (arg >= elimit) fn_val = EXP(arg)

ELSE

!      Use a continued fraction expansion

  arg = p * LOG(x) - x - lngamma(p)
  a = one - p
  b = a + x + one
  c = zero
  pn1 = one
  pn2 = x
  pn3 = x + one
  pn4 = x * b
  fn_val = pn3 / pn4
  60   a = a + one
  b = b + two
  c = c + one
  an = a * c
  pn5 = b * pn3 - an * pn1
  pn6 = b * pn4 - an * pn2
  IF (ABS(pn6) > zero) THEN
    rn = pn5 / pn6
    IF (ABS(fn_val - rn) <= MIN(tol, tol * rn)) GO TO 80
    fn_val = rn
  END IF

  pn1 = pn3
  pn2 = pn4
  pn3 = pn5
  pn4 = pn6
  IF (ABS(pn5) >= oflo) THEN

!      Re-scale terms in continued fraction if terms are large

    pn1 = pn1 / oflo
    pn2 = pn2 / oflo
    pn3 = pn3 / oflo
    pn4 = pn4 / oflo
  END IF
  GO TO 60
  80   arg = arg + LOG(fn_val)
  fn_val = one
  IF (arg >= elimit) fn_val = one - EXP(arg)
END IF

RETURN
END FUNCTION gammad



FUNCTION alnorm(x, upper) RESULT(fn_val)

!  Algorithm AS66 Applied Statistics (1973) vol.22, no.3

!  Evaluates the tail area of the standardised normal curve
!  from x to infinity if upper is .true. or
!  from minus infinity to x if upper is .false.

! ELF90-compatible version by Alan Miller
! Latest revision - 29 November 1997

REAL (dp), INTENT(IN) :: x
LOGICAL, INTENT(IN)   :: upper
REAL (dp)             :: fn_val

! Local variables
REAL (dp), PARAMETER :: zero = 0.0_dp, one = 1.0_dp, half = 0.5_dp, &
                        con = 1.28_dp
REAL (dp) :: z, y
LOGICAL   :: up

!*** machine dependent constants
REAL (dp), PARAMETER :: ltone = 7.0_dp, utzero = 18.66_dp

REAL (dp), PARAMETER :: p = 0.398942280444_dp, q = 0.39990348504_dp,   &
                        r = 0.398942280385_dp, a1 = 5.75885480458_dp,  &
                        a2 = 2.62433121679_dp, a3 = 5.92885724438_dp,  &
                        b1 = -29.8213557807_dp, b2 = 48.6959930692_dp, &
                        c1 = -3.8052E-8_dp, c2 = 3.98064794E-4_dp,     &
                        c3 = -0.151679116635_dp, c4 = 4.8385912808_dp, &
                        c5 = 0.742380924027_dp, c6 = 3.99019417011_dp, &
                        d1 = 1.00000615302_dp, d2 = 1.98615381364_dp,  &
                        d3 = 5.29330324926_dp, d4 = -15.1508972451_dp, &
                        d5 = 30.789933034_dp

up = upper
z = x
IF(z >=  zero) GO TO 10
up = .NOT. up
z = -z
10 IF(z <= ltone .OR. up .AND. z <= utzero) GO TO 20
fn_val = zero
GO TO 40
20 y = half*z*z
IF(z > con) GO TO 30

fn_val = half - z*(p-q*y/(y+a1+b1/(y+a2+b2/(y+a3))))
GO TO 40
30 fn_val = r*EXP(-y)/(z+c1+d1/(z+c2+d2/(z+c3+d3/(z+c4+d4/(z+c5+d5/(z+c6))))))
40 IF(.NOT. up) fn_val = one - fn_val

RETURN
END FUNCTION alnorm



FUNCTION lngamma(z) RESULT(lanczos)

!  Uses Lanczos-type approximation to ln(gamma) for z > 0.
!  Reference:
!       Lanczos, C. 'A precision approximation of the gamma
!               function', J. SIAM Numer. Anal., B, 1, 86-96, 1964.
!  Accuracy: About 14 significant digits except for small regions
!            in the vicinity of 1 and 2.

!  Programmer: Alan Miller
!              1 Creswick Street, Brighton, Vic. 3187, Australia
!  Latest revision - 14 October 1996

REAL (dp), INTENT(IN) :: z
REAL (dp)             :: lanczos

! Local variables

REAL (dp), PARAMETER  :: a(9) =  &
                         (/ 0.9999999999995183_dp, 676.5203681218835_dp, &
                        -1259.139216722289_dp, 771.3234287757674_dp, &
                         -176.6150291498386_dp, 12.50734324009056_dp, &
                           -0.1385710331296526_dp, 0.9934937113930748D-05, &
                            0.1659470187408462D-06 /),  &
                         zero = 0._dp, one = 1._dp, half = 0.5_dp,   &
                         sixpt5 = 6.5_dp, seven = 7._dp,  &
                         lnsqrt2pi = 0.9189385332046727_dp

REAL (dp) :: tmp
INTEGER   :: j

IF (z <= zero) THEN
  WRITE(*, *) 'Error: zero or -ve argument for lngamma'
  RETURN
END IF

lanczos = zero
tmp = z + seven
DO j = 9, 2, -1
  lanczos = lanczos + a(j)/tmp
  tmp = tmp - one
END DO
lanczos = lanczos + a(1)
lanczos = LOG(lanczos) + lnsqrt2pi - (z + sixpt5) + (z - half)*LOG(z + sixpt5)
RETURN

END FUNCTION lngamma


END MODULE Fisher_Exact
